unit cutoutu; 
{$include options.inc}
{$IFDEF FPC}{$mode objfpc}{$H+}{$ENDIF}

interface

uses
{$IFDEF FPC}LResources,  {$ENDIF}
  GLMisc,Classes, SysUtils,  Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ComCtrls;

type

  { TCutoutForm }

  TCutoutForm = class(TForm)
    HideBtn: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    X2TrackBar: TTrackBar;
    XTrackBar: TTrackBar;
    Y2TrackBar: TTrackBar;
    YTrackBar: TTrackBar;
    Z2TrackBar: TTrackBar;
    ZTrackBar: TTrackBar;
    procedure CutoutNearestSector(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HideBtnClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  CutoutForm: TCutoutForm;

implementation
uses mainunit {$IFDEF ENABLESCRIPT} ,scriptengine{$ENDIF};
{ TCutoutForm }
{$IFNDEF FPC} {$R *.dfm}   {$ENDIF}

procedure TCutoutForm.HideBtnClick(Sender: TObject);
begin
    XTrackBar.Position := 0;
  X2TrackBar.Position := 0;
     {$IFDEF FPC} TrackBarChange(nil); {$ENDIF}

end;

procedure TCutoutForm.TrackBarChange(Sender: TObject);
begin
  GLForm1.M_Refresh := TRUE;
  {$IFDEF ENABLESCRIPT}
  {$IFDEF darwin}
  //OSX can not use a timer during scripting
  if ScriptForm.PSScript1.running then
     exit;
  {$ENDIF}
  {$ENDIF}
  GLForm1.UpdateTimer.Enabled := true;
end;

type
  T4D = record
         X,Y,Z,D: single;
  end;

procedure TCutoutForm.CutoutNearestSector(Sender: TObject);
var
  lDx: single;
  lMin,lTest: T4D;
  lDirection: integer;
begin
  lDx := sqrt(1/3); //unit circle: by pythgorean equation...
  lMin.D := 1.0 / 0.0;
  for lDirection := 1 to 8 do begin
      if lDirection <= 4 then
        lTest.X := lDx
      else
        lTest.X := -lDx;
      Case lDirection of
        1,2,5,6: lTest.Y := lDx;
        else lTest.Y := -lDx;
      end;//Y case
      if odd(lDirection) then
        lTest.Z := lDx
      else
        lTest.Z := -lDx;

      lTest.D :=GLForm1.VectorCameraDx(lTest.X,lTest.Y,lTest.Z);
      if lTest.D < lMin.D then begin //we have found a new minimum
        lMin.X := lTest.X;
        lMin.Y := lTest.Y;
        lMin.Z := lTest.Z;
        lMin.D := lTest.D;
        //showmessage(floattostr(lTest.D));
      end;//new minimum  end; //
    end; //for each possible hemiquadrant
      //now set quadrants based on outcome...
      if lMin.X < 0 then begin
        XTrackBar.Position := 0;
        X2TrackBar.Position := 500;
      end else begin
        XTrackBar.Position := 500;
        X2TrackBar.Position := 1000;
      end;
      if lMin.Y < 0 then begin
        YTrackBar.Position := 0;
        Y2TrackBar.Position := 500;
      end else begin
        YTrackBar.Position := 500;
        Y2TrackBar.Position := 1000;
      end;
      if lMin.Z < 0 then begin
        ZTrackBar.Position := 0;
        Z2TrackBar.Position := 500;
      end else begin
        ZTrackBar.Position := 500;
        Z2TrackBar.Position := 1000;
      end;
     {$IFDEF FPC} TrackBarChange(nil); {$ENDIF}
end; //CutoutNearestSector

procedure TCutoutForm.FormShow(Sender: TObject);
begin
   if XTrackBar.Tag = 0 then begin//set default value if the first time this window is opened
    CutoutNearestSector(nil);
    XTrackBar.Tag := 1; //use users settings in future
  end; //if 1st time
end;


{$IFDEF FPC}
initialization
  {$I cutoutu.lrs}
{$ENDIF}


end.

