unit edgefilter;
interface

uses define_types, dialogs,Texture_3D_Unit,OpenGL1x, {Windows,} IniFiles, Prefs,StdCtrls,Classes;

procedure EdgeDetectZ (var lTexture: TTexture; lMinScaled,lMaxScaled, lThresh: single; lDilateCylces: integer);
procedure DecimateVol (var lTexture: TTexture; lPercent: integer);

implementation


uses SysUtils, mainunit,histogram;

procedure EdgeDetectVol (var lIntenVolume: bytep0; lX,lY,lZ: integer; lThreshIn: single);
var
  lNeighborInten,lCenterInten,lCenterInten6,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  ValueI,lVox,lnVox: integer;
  lOutVolume: bytep0;
  lThresh,lF: single;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  if lThreshIn > 0.000001 then
    lThresh := lThreshIn
  else
    lThresh := 1;
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lCenterInten := lIntenVolume^[lPos];
        lCenterInten6 := lCenterInten*6;
        lNeighborInten :=
          lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
          +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
          +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
        if lCenterInten6 > lNeighborInten then begin
          lCenterInten6 := lCenterInten6-lNeighborInten;
          lF := lCenterInten  / lThresh;
          if lCenterInten6 > lF then
            lOutVolume^[lPos] := 255;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure DespeckleVol (var lIntenVolume: bytep0; lX,lY,lZ: integer);
var
  lNeighborInten,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  lnVox: integer;
  lOutVolume: bytep0;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lOutVolume^[lPos] := lIntenVolume^[lPos];
        if lIntenVolume^[lPos] <> 0 then begin
          lNeighborInten :=
            lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
            +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
            +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
          if lNeighborInten = 0 then
            lOutVolume^[lPos] := 0;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure GrowVol (var lIntenVolume: bytep0; lX,lY,lZ: integer);
var
  lNeighborInten,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  ValueI,lnVox: integer;
  lOutVolume: bytep0;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lOutVolume^[lPos] := lIntenVolume^[lPos];
        if lIntenVolume^[lPos] = 0 then begin
          lNeighborInten :=
            lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
            +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
            +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
          if lNeighborInten <> 0 then
            lOutVolume^[lPos] := 255;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure MaskVolume (var lTexture: TTexture; var lIntenVolume: bytep0);
var
  lVox,lnVox,ValueI: integer;
begin
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  if lTexture.RawUnscaledImg16 <> nil then begin //16
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
        lTexture.RawUnscaledImg16^[lVox] := 0;
  end else if lTexture.RawUnscaledImg32 <> nil then begin //32-bit
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
        lTexture.RawUnscaledImg32^[lVox] := 0;
  end else if (lTexture.RawUnscaledImg8 <> nil) then begin //8-bit
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
           lTexture.RawUnscaledImg8^[lVox] := 0;
  end else if (lTexture.RawUnscaledImgRGBA <> nil) then begin
    ValueI := 0; //indexed from 0, RGBA quad
    for lVox := 1 to lnVox do begin
      if lIntenVolume^[lVox] = 0 then begin
        lTexture.RawUnscaledImgRGBA^[ValueI] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+1] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+2] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+3] := 0;
      end;
      ValueI := ValueI + 4;
    end;
  end;
end;

procedure DecimateVol (var lTexture: TTexture; lPercent: integer);
//%=100 deletes all voxels, %=25 deletes one quarter
var
  lVox,lnVox: integer;
  lIntenVolume: bytep0;
  ValueI: byte;
begin
  if lTexture.DataType <> GL_RGBA then
    exit;
  if lTexture.FiltImg = nil then
    exit;
  if (lPercent < 1) or (lPercent > 99) then
    exit;
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  getmem(lIntenVolume,lnVox);
  for lVox := 0 to lnVox do begin
            if random(100) > lPercent then
              ValueI := 0
          else
               ValueI := 255;
           lIntenVolume^[lVox] := ValueI;
  end; //for each vox
  MaskVolume (lTexture, lIntenVolume);
  freemem(lIntenVolume);
end;

procedure EdgeDetectZ (var lTexture: TTexture; lMinScaled,lMaxScaled,lThresh: single; lDilateCylces: integer);
var
  ValueI,lVox,lnVox: integer;
  lMin,lMax,lIntercept,lSlope: single;
  lIntenVolume: bytep0;
  //lF: File;
begin
  if lTexture.DataType <> GL_RGBA then
    exit;
  if lTexture.FiltImg = nil then
    exit;
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  lMin := Scaled2Unscaled(lMinScaled,lTexture);
  lMax := Scaled2Unscaled(lMaxScaled,lTexture);
  if lMax = lMin then
    exit;
  if lMax < lMin then begin
      lSlope := lMax;
      lMax := lMin;
      lMin := lSlope;
  end;
  lIntercept := lMin;
  lSlope := 255/(lMax-lMin);
  getmem(lIntenVolume,lnVox);
  if lTexture.RawUnscaledImg16 <> nil then begin //16
    for lVox := 0 to lnVox do begin
            ValueI := round((lTexture.RawUnscaledImg16^[lVox]-lINtercept)*lSlope);
            if ValueI < 0 then
              ValueI := 0;
            if ValueI > 255 then
              ValueI := 255;
            lIntenVolume^[lVox] := ValueI;
    end; //for each vox
  end else if lTexture.RawUnscaledImg32 <> nil then begin //32-bit
    for lVox := 0 to lnVox do begin
            ValueI := round((lTexture.RawUnscaledImg32^[lVox]-lIntercept)*lSlope);
            if ValueI < 0 then
              ValueI := 0;
            if ValueI > 255 then
               ValueI := 255;
           lIntenVolume^[lVox] := ValueI;
    end; //for each vox
  end else if (lTexture.RawUnscaledImg8 <> nil) then begin //8-bit
    for lVox := 0 to lnVox do
           lIntenVolume^[lVox] := lTexture.RawUnscaledImg8^[lVox];
  end else if (lTexture.RawUnscaledImgRGBA <> nil) then begin
    ValueI := 1; //indexed from 0, so 1 = green in RGBA quad
    for lVox := 1 to lnVox do begin
      lIntenVolume^[lVox] := lTexture.RawUnscaledImgRGBA^[ValueI];
      ValueI := ValueI + 4;
    end;
  end else begin
      freemem(lIntenVolume);
      Showmessage('Serious error with Edge filter: unknown datatype.');
      exit;
  end;
  EdgeDetectVol (lIntenVolume,lTexture.Dim[1],lTexture.Dim[2],lTexture.Dim[3],lThresh);
  DespeckleVol (lIntenVolume,lTexture.Dim[1],lTexture.Dim[2],lTexture.Dim[3]);
  if lDilateCylces > 0 then
    for ValueI := 1 to lDilateCylces do
      GrowVol (lIntenVolume,lTexture.Dim[1],lTexture.Dim[2],lTexture.Dim[3]);
  MaskVolume (lTexture, lIntenVolume);
  freemem(lIntenVolume);
  (*ValueI := 0;
  for lVox := 0 to (lnVox) do begin
      if lIntenVolume^[lVox] = 0 then
            lTexture.FiltImg^[ValueI+3] := 0//Alpha
      else if lIntenVolume^[lVox] <> 255 then
            lTexture.FiltImg^[ValueI+3] := lTexture.FiltImg^[ValueI+3] shr 1;//Alpha
      lIntenVolume^[lVox] := lTexture.FiltImg^[ValueI+3];
      inc(ValueI,4);
  end; //for each vox
  //output
	Filemode := 1;
	AssignFile(lF, 'c:\phantom.img');
	Rewrite(lF,1);
	BlockWrite(lF,lIntenVolume^, lnVox+1 );
	CloseFile(lF);
	Filemode := 2;
  freemem(lIntenVolume);*)
end;


end.
