unit mainunit;
{$include options.inc}
{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
interface
{$H+}
uses
{$IFDEF FPC}LResources,GLViewer,
  {$ELSE}
         {$IFDEF ENABLEAVI}  GLAVIRecorder, {$ENDIF}
         JPEG,PNGImage,Windows, Messages,Types,Clipbrd,GLWin32Viewer,
  {$ENDIF}
  {$IFDEF ENABLEOVERLAY}overlay,{$ENDIF}
Buttons,Classes,colorbar2D,ComCtrls,Controls,define_types,Dialogs,
ExtCtrls,Forms, GLBitmapFont, GLWindowsFont, GLCadencer,
  GLScene, GLHUDObjects, GLMisc, GLObjects,
GLCanvas,GLContext,GLCrossPlatform,GLGraphics, GLTexture,
Graphics,GraphicsMathLibrary,Menus,OpenGL1x,
prefs,StdCtrls,SysUtils,texture_3d_unit,userdir,VectorGeometry,scaleimageintensity;
var
    gOrthoX : single = 0.5;
    gOrthoY : single = 0.5;
    gOrthoZ : single = 0.5;
    gPrefs: TPrefs;
    gTexture3D : TTexture;
    gRendering : boolean = false;
type
  TGLForm1 = class(TForm)
    About1: TMenuItem;
    About2: TMenuItem;
    AnimateMenu: TMenuItem;
    Auto1: TMenuItem;
    AutoRunTimer: TTimer;
    Axial1: TMenuItem;
    Axial2: TMenuItem;
    BackgroundColor1: TMenuItem;
    ClipMenu: TMenuItem;
    Colorandtransarency1: TMenuItem;
    ColorbarFormMenu: TMenuItem;
    Copy1: TMenuItem;
    Coronal1: TMenuItem;
    Coronal2: TMenuItem;
    CrossHairs1: TMenuItem;
    Cutout1: TMenuItem;
    Edit1: TMenuItem;
    Exit1: TMenuItem;
    File1: TMenuItem;
    Frame: TGLLines;
    FrameMenu: TMenuItem;
    GLCadencer: TGLCadencer;
    GLCamera1: TGLCamera;
    GLDirectOpenGL1: TGLDirectOpenGL;
    GLHUDText1: TGLHUDText;
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLWindowsBitmapFont1: TGLWindowsBitmapFont;
    Hidden1: TMenuItem;
    MainMenu1: TMainMenu;
    MIPMenu: TMenuItem;
    Mosaicdesigner1: TMenuItem;
    N2render: TMenuItem;
    N1slices: TMenuItem;
    N3render: TMenuItem;
    N1File: TMenuItem;
    N1render: TMenuItem;
    N4render: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Options1: TMenuItem;
    Overlays1: TMenuItem;
    PerspectiveMenu: TMenuItem;
    ColorDialog1: TColorDialog;
    RenderMenu: TMenuItem;
    RotationAnimation1: TMenuItem;
    Sagittal1: TMenuItem;
    Sagittal2: TMenuItem;
    SaveDialog1: TSaveDialog;
    SavePicture1: TMenuItem;
    Saverotationbitmaps1: TMenuItem;
    ScreenCapture: TGLCadencer;
    Scripting1: TMenuItem;
    ShowRenderMenu: TMenuItem;
    ShowslicesMenu: TMenuItem;
    SlicesMenu: TMenuItem;
    SliceTextMenu1: TMenuItem;
    Timer: TTimer;
    UpdateTimer: TTimer;
    View2: TMenuItem;
    x11: TMenuItem;
    x21: TMenuItem;
    x31: TMenuItem;
    Zoom1: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    Crosshaircolor1: TMenuItem;
    Crosshairthickness1: TMenuItem;
{$IFNDEF FPC}   AVIRecorder1: TAVIRecorder;
    {$ENDIF}
    procedure Crosshaircolor1Click(Sender: TObject);
    procedure Crosshairthickness1Click(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure GLSceneViewer1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure StopTimers;
    procedure StopScripts;
    procedure CLUTTimerXOn;
    procedure ReportAziElev;
    procedure AdjustFormPos (var lForm: TForm);
    //procedure LoadDTI(lFA: string);
    procedure SetView(ShowSlicesHideRender,Refresh: boolean);
    procedure ApplyCTContrast;
    procedure TimerTimer(Sender: TObject);
    function VectorCameraDx (lX,lY,lZ: single): single;
    procedure About2Click(Sender: TObject);
    procedure AnimateMenuClick(Sender: TObject);
    procedure Axial1Click(Sender: TObject);
    procedure Axial2Click(Sender: TObject);
    procedure BackgroundColor1Click(Sender: TObject);
    procedure ClipMenuClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure DisplayPrefs (var lPrefs: TPrefs);
    procedure Coronal1Click(Sender: TObject);
    procedure Coronal2Click(Sender: TObject);
    Procedure CreateCutout;
    procedure Cutout1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SetFormSize(FormWidth,FormHeight: integer);
    procedure ViewingDistance(lDin: single);
    procedure Zoom(WheelDelta: integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
    WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FrameMenuClick(Sender: TObject);
    procedure GLCadencerProgress(Sender: TObject; const deltaTime,newTime: Double);
    Procedure GLDirectOpenGL1Render(Sender: TObject; var rci: TRenderContextInfo);
    procedure OrthoClick (X,Y: integer);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    function LoadDatasetNIFTI(lFilename: string; lStopScript: boolean): boolean;
    procedure MIPChange(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure PerspectiveMenuClick(Sender: TObject);
    procedure RepositionCameraX(var lV: TGLCoordinates);
    //procedure RightGLCoordinates(var lV: TGLCoordinates);
    procedure RotationAnimation1Click(Sender: TObject);
    procedure Sagittal1Click(Sender: TObject);
    procedure Sagittal2Click(Sender: TObject);
    procedure SavePicture(lFilename: string);
    procedure SavePicture1Click(Sender: TObject);
    procedure Saverotationbitmaps1Click(Sender: TObject);
    procedure ScreenCaptureProgress(Sender: TObject; const deltaTime,newTime: Double);
    procedure SetViewerClipPlane (lDistance: integer);
    procedure SetViewerClipPlaneAE (lDistance,lAzi,lElev: integer);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ShowOrthoSliceText(var rci: TRenderContextInfo);
    procedure ShowOrthoSlice (var rci: TRenderContextInfo);
    procedure ShowRenderMenuClick(Sender: TObject);
    procedure UpdateMRU;//most-recently-used menu
    procedure OpenMRU(Sender: TObject);
    procedure Mosaicdesigner1Click(Sender: TObject);
    procedure DrawMosaic (lStr: string);
    procedure ZoomClick(Sender: TObject);
    procedure CrossHairs1Click(Sender: TObject);
    procedure Colorandtransarency1Click(Sender: TObject);
    procedure Scripting1Click(Sender: TObject);
    procedure ShowslicesMenuClick(Sender: TObject);
    procedure DropFile(lFilename: string);
    function LoadParamStr (lExecute: boolean): boolean;
    procedure Camera2AzimuthElevationDeg(lAzi,lElev: single);
    procedure CheckFilename (var lFilenameX: string);
    procedure MedianSmoothing;
    procedure EdgedetectionX (lThresh: single; lDilateCycles: integer);
    procedure DecimateV (lPercent: integer);
    procedure AutoRunTimerTimer(Sender: TObject);
    procedure GLSceneViewer1DblClick(Sender: TObject);
    procedure UpdateTimerTimer(Sender: TObject);
    procedure Overlays1Click(Sender: TObject);
    procedure ColorbarFormMenuClick(Sender: TObject);
    procedure SliceTextMenu1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    {$IFNDEF FPC}    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES; {$ENDIF}
  protected
      Procedure Calculate_Transfer_Function;
  public
    { public declarations }
    gOrthoZoom,gObjRed,gObjGreen,gObjBlue: single;
    gGLcoords,gGLCoords2,gGLCoords3: TGLCoordinates;
    Snapshot,nSnapshots,Start_mx,Start_my,M_mx,M_my : Integer;
    gTexture : TGLTextureHandle;
    gRefreshCLUT, M_Refresh, M_DrawLUTs : Boolean;

  end;
var
  GLForm1: TGLForm1;
    gDrawMosaicStr : string;
implementation

uses
{$IFDEF ENABLESCRIPT} scriptengine,{$ENDIF}
{$IFDEF ENABLECLIP} clipu,{$ENDIF}
{$IFDEF ENABLECUTOUT} cutoutu, {$ENDIF}
{$IFNDEF FPC} shellAPI,{$ENDIF}
{$IFDEF ENABLEABOUT}about,{$ENDIF}
clut,slices2D,
{$IFDEF ENABLEMOSAIC} mosaicprefs, {$ENDIF}
{$IFDEF ENABLECLUT}   clutprefs,{$ENDIF}
{$IFDEF ENABLECOLORBAR} colorbar, {$ENDIF}
 {$IFDEF ENABLEPREF}uprefsform,  {$ENDIF}
     readint, edgefilter,smooth, commandsu;  
{$IFNDEF FPC} {$R *.dfm}   {$ENDIF}
{ TGLForm1 }
Const
  DIAGONAL_LENGTH = 1.732;
  kInitialDx = 1.5;
  kAnimation_Rotation = 5;

Var

  gGLversionAtleast2 : integer = -1;//-1 means unchecked, 0 means no, 1 means yes
  gAnimation_Rotation : single = kAnimation_Rotation;
  clip0 : Array [0..3] Of Double = (-1.0, 0.0, 0.0, 1 / 2.0);//right
  clip1 : Array [0..3] Of Double = (1.0, 0.0, 0.0, 1 / 2.0);//left
  clip2 : Array [0..3] Of Double = (0.0, -1.0, 0.0, 1 / 2.0);//anterior
  clip3 : Array [0..3] Of Double = (0.0, 1.0, 0.0, 1 / 2.0);//posterior
  clip4 : Array [0..3] Of Double = (0.0, 0.0, -1.0, 1 / 2.0);//superior [head]
  clip5 : Array [0..3] Of Double = (0.0, 0.0, 1.0, 1 / 2.0);//inferior [feet]

procedure TGLForm1.DisplayPrefs (var lPrefs: TPrefs);
begin
  with lPrefs do begin
    FrameMenu.Checked :=Frame;
    SetView(OrthoSliceView,True);
    CrossHairs1.checked := CrossHairs;
    SliceTextMenu1.checked := SliceText;
    //ColorbarText := true;
    //SliceText := false;
    //CrossHairs := false;
{$IFDEF ENABLECOLORBAR}
    ColorBarForm.ColorbarTextCheck.checked := ColorbarText;

    ColorBarForm.ShowDefs(lPrefs);{$ENDIF}
    PerspectiveMenu.Checked :=perspective;
{$IFDEF ENABLEOVERLAY}
    OverlayForm.OverlayColorFromZeroMenu.checked := OverlayColorFromZero;
    OverlayForm.InterpolateMenu.checked := InterpolateOverlays;
    OverlayForm.BackgroundMaskMenu.checked :=MaskOverlayWithBackground;
    OverlayForm.SetSubmenuWithTag(OverlayForm.Onotheroverlays1,lPrefs.OverlayAlpha);
    OverlayForm.SetSubmenuWithTag(OverlayForm.Onbackground1,lPrefs.BackgroundAlpha);
{$ENDIF}
    ColorDialog1.Color := BackgroundCOlor;
    GLSceneViewer1.Buffer.BackgroundColor := BackgroundColor;
  end;//with lPrefs
end; //Proc DisplayDefaultPrefs

procedure TGLForm1.DropFile(lFilename: string);
begin
{$IFDEF ENABLESCRIPT}
  if UpCaseExt(lFilename) = kScriptExt then begin //auto run scripts on drag/drop
    ScriptForm.OpenScript(lFilename);
    ScriptForm.Compile1.Click;
   end else  {$ENDIF}
         LoadDatasetNIFTI(lFileName,true);
end;

function TGLForm1.LoadParamStr (lExecute: boolean): boolean;
var
	I,lParamPos: integer;
	lStr: string;
begin
  result := false;
  lParamPos := 1;
  if (ParamCount < lParamPos) then exit;
  I := lParamPos;
  repeat
		if I = lParamPos then
			lStr := ParamStr(I)
		else
			lStr := lStr +' '+ ParamStr(I);
		inc(I);
  until (I>ParamCount) or (fileexistsex(lStr));
  //lParamPos := I;
  if fileexistsex(lStr) then begin
    result := true;
	  if lExecute then
      DropFile(lStr);
  end;
end;

  {$IFNDEF FPC}
procedure TGLForm1.WMDropFiles(var Msg: TWMDropFiles);  //implement drag and drop
var  CFileName: array[0..MAX_PATH] of Char;
  //lFilename: string;
begin
  try
   if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then begin
      //lFilename := CFilename;
      DropFile(CFilename);
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;//Proc WMDropFiles

procedure TGLForm1.FormDropFiles(Sender: TObject;
  const FileNames: array of String);
begin
   //for fpc compatibility
end;
{$ELSE}
procedure TGLForm1.FormDropFiles(Sender: TObject;
  const FileNames: array of String);
var
   lFilename: string;
begin
  if length(FileNames) < 1 then
     exit;
  lFilename := Filenames[0];
  LoadDatasetNIFTI(lFileName,true);
end;
{$ENDIF}

(*function ChangeEnd (lInStr,lNewEnd: string): string;
// filename_FA,V1 will return Filename_V1
var
  lLenStr,lLenEnd,lI: integer;
begin
  result := '';
  lLenStr := length(lInStr);
  lLenEnd := length(lNewEnd);
  if lLenStr < lLenEnd then
    exit;
  result := lInStr;
  if lLenEnd < 1 then
    exit;
  for lI := 1 to lLenEnd do
    result[lLenStr-lLenEnd+lI] := lNewEnd[lI];
end;

procedure TGLForm1.LoadDTI(lFA: string);
var
  lPath,lName,lExt,lV1: string;
begin
  LoadDatasetNIFTI(lFA,true);
  FilenameParts (lFA, lPath,lName,lExt);
  lV1 := ChangeEnd (lPath+lName,'V1')+lExt;
  if not Fileexists(lV1) then
    showmessage('Unable to find FSL vector named '+lV1);
  {$IFDEF ENABLEOVERLAY}
  //LoadDTI('C:\pas\mricrogl\source\dti_corr_fit_FA.nii.gz','C:\pas\mricrogl\source\dti_corr_fit_V1.nii.gz');
  OverlayForm.Addoverlay(lV1,1);
  OverlayForm.Addoverlay(lV1,2);
  OverlayForm.Addoverlay(lV1,3);
  AbsImgIntensity32(gOverlayImg[1] );
  AbsImgIntensity32(gOverlayImg[2] );
  AbsImgIntensity32(gOverlayImg[3] );
  OverlayForm.UpdateImageIntensityMinMax (1, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (2, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (3, 0,1);
{OVERLAYTRANSPARENCYONBACKGROUND(-2)}
  gPrefs.BackgroundAlpha := -2;
  OverlayForm.StatusPanelUpdate;
  OverlayForm.ChangeOverlayUpdate;
  OverlayForm.SetSubmenuWithTag(OverlayForm.Onbackground1,gPrefs.BackgroundAlpha);
{ShowForm}
  AdjustFormPos(TForm(OverlayForm));
  OverlayForm.show;
  {$ENDIF}
end;*)

procedure TGLForm1.Crosshaircolor1Click(Sender: TObject);
begin
    ColorDialog1.color := RGBA2TColor(gPrefs.CrosshairColor);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.CrosshairColor);
    GLSceneViewer1.refresh;
    ColorDialog1.Color := gPrefs.BackgroundColor;
end;



procedure TGLForm1.StopTimers;
begin
   Timer.Enabled := false;
   AutoRunTimer.enabled := false;
   UpdateTimer.enabled := false;
  GLCadencer.Enabled := false;
  ScreenCapture.Enabled := false;

end;

procedure TGLForm1.StopScripts;
begin
  {$IFDEF ENABLESCRIPT}
  ScriptForm.Stop1Click(nil);
  {$ENDIF}
end;

procedure TGLForm1.CLUTTimerXOn;
begin
gRefreshClut := true;
      UpdateTimer.Enabled := true;
    //GLForm1.SetFocus;
    //CLUTTimerX.enabled := true;
end;

(*procedure TGLForm1.CLUTTimerXTimer(Sender: if InputQuery('Computer to connect to', 'IP number:', Server) then
  if InputQuery('Port', 'Port:', Ports) then
    if Length(Server) > 0 then
     with ClientSocket do
      begin
        Host := Server;
        Port := strtoint(Ports);
 TObject);
begin
  //CLUTTimerX.enabled := false;
  CLUTForm.DrawCLUTa(gCLUTrec);
end;  *)

procedure TGLForm1.OpenMRU(Sender: TObject);//open template or MRU
//Templates have tag set to 0, Most-Recently-Used items have tag set to position in gMRUstr
var
	lFilename: string;
begin
     if Sender = nil then
        lFilename := gPrefs.PrevFilename[1]
     else
         lFilename := gPrefs.PrevFilename[(Sender as TMenuItem).tag];
		 LoadDatasetNIFTI(lFilename,true);
end;

procedure TGLForm1.UpdateMRU;//most-recently-used menu
const
        kMenuItems = 6;//with OSX users quit from application menu
var
  NewItem: TMenuItem;
	lPos,lN : integer;
begin
  While File1.Count > kMenuItems do File1.Items[kMenuItems].Free;
  lN := 0;
  for lPos := 1 to knMRU do begin//for each MRU
      if gPrefs.PrevFilename[lPos] <> '' then begin
		   inc(lN);
		   NewItem := TMenuItem.Create(Self);
		   NewItem.Caption :=ExtractFileName(gPrefs.PrevFilename[lPos]);//(ParseFileName(ExtractFileName(lFName)));
		   NewItem.Tag := lN;
                   {$IFDEF XFPC}
                    NewItem.onclick :=  @OpenMRU; //Lazarus
                    {$ELSE}
                     NewItem.onclick :=  OpenMRU;
                     {$ENDIF}
                    if lN < 10 then
                   {$IFDEF Darwin}
                    NewItem.ShortCut := ShortCut(Word('1')+ord(lN-1), [ssMeta]);
                     {$ELSE}
		   NewItem.ShortCut := ShortCut(Word('1')+ord(lN-1), [ssCtrl]);
                   {$ENDIF}
		   File1.Add(NewItem);
      end;//if mru exists
  end;//for each MRU
end;  //UpdateMRU

(* not used, but potentially useful
//change color of ambient lighting
// If lighting is blue, then object will have blue tint
begin
  if not RenderColorDialog.Execute then exit;
  gObjRed := (RenderColorDialog.Color and 255)/255;
  gObjGreen := ((RenderColorDialog.Color shr 8) and 255)/255;
  gObjBlue := ((RenderColorDialog.Color shr 16) and 255)/255;
  GLSceneViewer1.Invalidate;
end; //Objectcolor1Click
*)

procedure TGLForm1.RepositionCameraX(var lV: TGLCoordinates);
begin
    GLCamera1.Position := (lV);
end; //proc RepositionCamera

{$IFNDEF FPC}
procedure SaveImgAsPNGCore (var lImage: TBitmap; lFilename: string);
var
  PNG: TPNGObject;
begin
	if (lImage = nil) then begin
		Showmessage('No image found to save.');
		exit;
	end;
  PNG := TPNGObject.Create;
  try
    PNG.Assign(lImage);    //Convert data into png
    PNG.SaveToFile(ChangeFileExt(lFilename,'.png'));
  finally
    PNG.Free;
  end
end;
{$ELSE}
procedure SaveImgAsPNGCore (lImage: TBitmap; lFilename: string);
var
  PNG: TPortableNetworkGraphic;
begin
	if (lImage = nil) then begin
		Showmessage('No image found to save.');
		exit;
	end;
  PNG := TPortableNetworkGraphic.Create;
  try
    PNG.Assign(lImage);    //Convert data into png
    PNG.SaveToFile(ChangeFileExt(lFilename,'.png'));
  finally
    PNG.Free;
  end
end;
{$ENDIF}

//procedure SaveImgAsJPGCore (var lImage: TBitmap; lFilename: string);
procedure SaveImgAsJPGCore (lImage: TBitmap; lFilename: string);
var
  JpegImg : TJpegImage;
begin
   JpegImg := TJpegImage.Create;
   try
    JpegImg.Assign(lImage) ;
    JpegImg.SaveToFile(ChangeFileExt(lFilename,'.jpg')) ;
   finally
    JpegImg.Free
   end;
end;

{$IFNDEF UNUSED}  //Old GLScene for Darwin used routines above - check PPC
//Make background opaque...
procedure xBGRA32ToRGBA32(dest : PGLPixel32Array; pixelCount : Integer); register;
begin
   while pixelCount>0 do begin
      dest^[pixelcount].a  := 255;  //output to blue
      Dec(pixelCount);
   end;
end;

procedure SwizzleGL (lGLbmp :TGLBitmap32);
var
   lY, FHeight,FWidth: integer;
begin
     FHeight := lGLbmp.Height;
     FWidth := lGLBmp.Width;
     if (FHeight < 1) or (FWidth < 1) then
        exit;
     for lY := 0 to (FHeight-1) do begin
         xBGRA32ToRGBA32(lGLbmp.ScanLine[(FHeight-1)-lY],FWidth);
     end;
end;
{$ELSE}  //IF DARWIN... ELSE....
procedure xBGRA32ToRGBA32(dest : PGLPixel32Array; pixelCount : Integer); register;
var
   lColor: TGLPixel32;
begin
   while pixelCount>0 do begin
      lColor := dest^[pixelcount];
      dest^[pixelcount].r  := lColor.b;//src^[pixelcount].a;  //alpha
      dest^[pixelcount].g  := lColor.g;//src^[pixelcount].r; //output to red
      dest^[pixelcount].b  := lColor.r;//src^[pixelcount].g; //output to green
      dest^[pixelcount].a  := 255;  //output to blue
      Dec(pixelCount);
   end;
end;

procedure SwizzleGL (lGLbmp :TGLBitmap32);
//On Linux the RGBA data in GLBitmap32 is stored in the reverse order: ABGR -> RGBA
var
   lY, FHeight,FWidth: integer;
begin
     FHeight := lGLbmp.Height;
     FWidth := lGLBmp.Width;
     if (FHeight < 1) or (FWidth < 1) then
        exit;
     //FDataSize:=FWidth*FHeight*4;
     for lY := 0 to (FHeight-1) do begin
         xBGRA32ToRGBA32(lGLbmp.ScanLine[(FHeight-1)-lY],FWidth);
     end;
end;
{$ENDIF}//IF DARWIN ...  ELSE

procedure TGLForm1.SavePicture(lFilename: string);
{$IFDEF FPC}
var
  GLbmp32 :TGLBitmap32;
begin
          GLSceneViewer1.Buffer.BackgroundAlpha := 255; // backgound ...
             GLbmp32 := GLSceneViewer1.Buffer.CreateSnapShot;
             SwizzleGL(GLbmp32);
              if (UpCaseExt(lFilename) = '.JPG') or (UpCaseExt(lFilename) = '.JPEG') then
                 SaveImgAsJPGCore (GLbmp32.Create32BitsBitmap, lFilename)
              else
                 SaveImgAsPNGCore (GLbmp32.Create32BitsBitmap, lFilename);
             GLbmp32.Free;
end;
{$ELSE} //Delphi code
var
  lImg : TBitmap;
begin
  lImg := GLSceneViewer1.Buffer.CreateSnapShotBitmap;
  if (UpCaseExt(lFilename) = '.JPG') or (UpCaseExt(lFilename) = '.JPEG') then
    SaveImgAsJPGCore (lImg, lFilename)
  else
     SaveImgAsPNGCore (lImg,lFilename);
  lImg.Free;
end;
{$ENDIF}

procedure TGLForm1.SavePicture1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then
    exit;
  SavePicture(SaveDialog1.FileName);
end;

procedure TGLForm1.Saverotationbitmaps1Click(Sender: TObject);
  //Rotate 360-degrees around azimuth, saving N at evenly spaced locations
const
  kMaxViews = 72;
var
  lViews: integer;
begin
  lViews := ReadIntForm.GetInt('How many images different angles do you want?',2,12,360);
  if (lViews < 1) or (lViews > kMaxViews) then begin
      Showmessage('Error: please enter a number between 1 and '+inttostr(kMaxViews));
      exit;
  end;
  gAnimation_Rotation := 360 / lViews;
  if not SaveDialog1.Execute then
    exit;
  Snapshot := 0;
  nSnapShots := lViews;
  ScreenCapture.Enabled := true;
end; //proc Saverotationbitmaps1Click

procedure TGLForm1.Exit1Click(Sender: TObject);
begin
    GLForm1.Close;
end;

procedure SetZooms (var lX,lY,lZ: single);
var
  lMinS: single;
begin
  lX := 1;
  lY := 1;
  lZ := 1;
  if (not gPrefs.ProportionalStretch) then
    exit;
  //unlike NIFTI header, gTexture.pixmm is absolute - never negative... otherwise we would need abs()
  lMinS := FloatMinVal(gTexture3D.pixmm[1],gTexture3D.pixmm[2],gTexture3D.pixmm[3]);
  if lMinS = 0 then
    exit;
  lX := (gTexture3D.PixMM[1]) / lMinS;
  lY := (gTexture3D.PixMM[2]) / lMinS;
  lZ := (gTexture3D.PixMM[3]) / lMinS;
end;

procedure TGLForm1.OrthoClick(X,Y: integer);
var
  lI: integer;
  lZoomDim: array [1..3] of single;
begin
  SetZooms (lZoomDim[1],lZoomDim[2],lZoomDim[3]);
  for lI := 1 to 3 do
    lZoomDim[lI] := lZoomDim[lI]*abs(gOrthoZoom) * gTexture3D.dim[lI];
  if (X < lZoomDim[1]) and (Y < lZoomDim[3]) then begin //coronal
    gOrthoX := X/lZoomDim[1];
    gOrthoZ := (lZoomDim[3]-Y)/lZoomDim[3];
    GLSceneViewer1.Refresh;
    exit;
  end;
  if (X < (lZoomDim[1] + lZoomDim[2])) and (Y < lZoomDim[3]) then begin //sag
    gOrthoY := (X-lZoomDim[1] )/lZoomDim[2];
    gOrthoZ := (lZoomDim[3]-Y)/lZoomDim[3];
    GLSceneViewer1.Refresh;
    exit;
  end;
  if (X < lZoomDim[1]) and (Y < (lZoomDim[3]+lZoomDim[2])) then begin //axial
    gOrthoX := X/lZoomDim[1];
    gOrthoY := (lZoomDim[2]- (Y-lZoomDim[3]) )/lZoomDim[2];
    GLSceneViewer1.Refresh;
    exit;
  end;
  GLSceneViewer1DblClick(nil);
end;

procedure TGLForm1.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If gPrefs.OrthoSliceView then begin
    OrthoClick(X,Y);
    exit;
  end;
  GLCadencer.Enabled := false;
  //if (not (ssLeft in Shift)) then begin
  If  (ssRight in Shift) Then begin
    //M_mx := ContrastForm.BiasTrack.Position;
    //M_my := ContrastForm.GainTrack.Position;
  end else begin
    M_mx := x;
    M_my := y;
  end;
  Start_mx := x;
  Start_My := y;
end;

procedure TGLForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
//Change camera azimuth and elevation
var
  lX,lY: Integer;
Begin
  If gPrefs.OrthoSliceView then begin
   if (SSLeft in Shift) then
      OrthoClick(X,Y);
    exit;
  end;
  If not (ssRight in Shift) and not (ssLeft in Shift) Then
    exit;
  If  (ssRight in Shift) Then begin
  //if (not (ssLeft in Shift)) then begin
    //ContrastForm.BiasTrack.Position := ((x-Start_mx ) div 4)+M_mx;
    //ContrastForm.GainTrack.Position := ((Start_my - y) div 4)+M_my;
    //{$IFDEF FPC} ContrastForm.BiasTrackChange(nil);  {$ENDIF}
  end else begin
    lX := X;
    lY := Y;
    if (ssAlt in Shift)  then begin
      lX := M_mx;
      ReportAziElev;
    end;
    if  (ssCtrl in Shift) then begin
      lY := M_my;
      ReportAziElev;
    end;
    GLCamera1.MoveAroundTarget ((M_my - ly), (M_mx - lx));
    M_mx := lx;
    M_my := ly;
  end;
End; //proc GLSceneViewerMouseMove

procedure TGLForm1.MIPChange(Sender: TObject);
begin
  M_Refresh := TRUE;
  GLSceneViewer1.Invalidate;
end;

procedure TGLForm1.Copy1Click(Sender: TObject);
{$IFDEF FPC}
begin
     GLSceneViewer1.Buffer.CreateSnapShotBitmap.SaveToClipboardFormat(2);
end;
{$ELSE}
var
  MyFormat : Word;
  AData: THandle;
  APalette : HPalette;
begin
  GLSceneViewer1.Buffer.CreateSnapShotBitmap.SaveToClipboardFormat(MyFormat,AData,APalette);
  ClipBoard.SetAsHandle(MyFormat,AData);
end; //proc Copy1Click }
{$ENDIF}


procedure TGLForm1.BackgroundColor1Click(Sender: TObject);
begin
    ColorDialog1.color := GLSceneViewer1.Buffer.BackgroundColor ;
      if not ColorDialog1.Execute then exit;
  GLSceneViewer1.Buffer.BackgroundColor := ColorDialog1.Color;
end;

procedure TGLForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
Begin
  gGLversionAtleast2 := 0; //stop rendering
  InitTexture(gTexture3D);//release memory .Free;
  gTexture.Free;
  gPrefs.Frame := FrameMenu.Checked;
  gPrefs.Perspective := PerspectiveMenu.Checked;
  gPrefs.SliceText := SliceTextMenu1.Checked;
  gPrefs.BackgroundColor := ColorDialog1.Color;
  gPrefs.FormWidth := glForm1.Width;
  gPrefs.FormHeight := glForm1.Height;
  IniFile(false,IniName,gPrefs);
end;

procedure ScreenRes(var lVidX,lVidY: integer);
{$IFDEF FPC}
begin
    lVidX := Screen.Width;
    lVidY := Screen.Height;
    //bug
end;
{$ELSE}
var
   DC: HDC;
   //lBits: integer;
begin
  DC := GetDC(0);
  try
   //lBits :=(GetDeviceCaps(DC, BITSPIXEL));
   lVidX :=(GetDeviceCaps(DC, HORZRES));
   lVidY :=(GetDeviceCaps(DC, VERTRES));
  finally
       ReleaseDC(0, DC);
  end; // of try/finally
end;//screenres
{$ENDIF}

procedure TGLForm1.SetFormSize(FormWidth,FormHeight: integer);
var
  lVidX,lVidY: integer;
begin
  {$IFNDEF Darwin}  //Darwin does not resize the GLSceneViewer correctly...
  ScreenRes(lVidX,lVidY);
  if lVidX > FormWidth then
    GLForm1.Width := FormWidth;
  if (lVidy-20) > FormHeight then //give a bit of room for dock
    GLForm1.Height := FormHeight;
   {$ENDIF}
end;

procedure TGLForm1.FormCreate(Sender: TObject);
Begin

        gRefreshCLUT := false;
     M_refresh := false;
  gDrawMosaicStr := '';
  gTexture := TGLTextureHandle.Create;
  InitTexture(gTexture3D);
  gObjRed := 1;
  gObjGreen := 1;
  gObjBlue := 1;
  M_DrawLUTS := false;
  gGLcoords:= TGLCoordinates.Create(self);
  gGLcoords2:= TGLCoordinates.Create(self);
  gGLcoords3:= TGLCoordinates.Create(self);
    {$IFDEF Darwin}
        {$IFNDEF LCLgtk} //only for Carbon compile
        Edit1.visible := false;
        Exit1.visible := false;//with OSX users quit from application menu
           BackgroundColor1.ShortCut := ShortCut(Word('B'), [ssMeta]);
            Open1.ShortCut := ShortCut(Word('O'), [ssMeta]);
           //Copy1.ShortCut := ShortCut(Word('C'), [ssMeta]);
FrameMenu.ShortCut := ShortCut(Word('F'), [ssMeta]);
          // PerspectiveMenu.ShortCut := ShortCut(Word('P'), [ssMeta]);
          MIPMenu.ShortCut := ShortCut(Word('M'), [ssMeta]);
          // Axial1.ShortCut := ShortCut(Word('A'), [ssMeta]);
          // Coronal1.ShortCut := ShortCut(Word('C'), [ssMeta]);
          //           Sagittal1.ShortCut := ShortCut(Word('S'), [ssMeta]);
           Showslicesmenu.ShortCut := ShortCut(Word('G'), [ssMeta]);
           ShowRenderMenu.ShortCut := ShortCut(Word('G'), [ssMeta]);
           Scripting1.ShortCut := ShortCut(Word('S'), [ssMeta]);
           Colorandtransarency1.ShortCut := ShortCut(Word('T'), [ssMeta]);
   //        AnimateMenu.ShortCut := ShortCut(Word('R'), [ssMeta]);
           Cutout1.ShortCut := ShortCut(Word('X'), [ssMeta,ssAlt]);

           Axial2.ShortCut := ShortCut(Word('A'), [ssMeta,ssAlt]);
           Coronal2.ShortCut := ShortCut(Word('C'), [ssMeta,ssAlt]);
           Sagittal2.ShortCut := ShortCut(Word('S'), [ssMeta,ssAlt]);
           //RotationAnimation1.ShortCut := ShortCut(Word('R'), [ssMeta,ssAlt]);
           ZoomIn1.ShortCut := ShortCut(Word('Z'), [ssMeta]);
           ZoomOut1.ShortCut := ShortCut(Word('Z'), [ssMeta,ssAlt]);
                           //need to change MRU number
        {$ENDIF}
 {$ENDIF}
    {$IFNDEF ENABLESCRIPT}
  Scripting1.Visible := false;
  {$ENDIF}

  {$IFNDEF FPC}DragAcceptFiles(Handle, True); {$ENDIF}//drag&drop
  IniFile(true,IniName,gPrefs);
  SetFormSize(gPrefs.FormWidth,gPrefs.FormHeight);
  //end formsize
  FrameMenu.Checked := gPrefs.Frame;
  //showmessage('xx2');
  PerspectiveMenu.Checked := gPrefs.Perspective;
  SliceTextMenu1.Checked := true; //gPrefs.SliceText;
  CrossHairs1.checked := gPrefs.CrossHairs;
  //ColorBarMenu.checked := gPrefs.Colorbar;
  SetView( gPrefs.OrthoSliceView,True);
  //MIPmenu.checked := gPrefs.MaximumIntensityProjection;
  FrameMenuClick(nil);
  if gPrefs.Perspective then
    GLCamera1.CameraStyle := csPerspective
  else
    GLCamera1.CameraStyle := csOrthogonal;
  ColorDialog1.Color := gPrefs.BackgroundColor;
  GLSceneViewer1.Buffer.BackgroundColor := ColorDialog1.Color;
End; //Proc FormCreate

procedure TGLForm1.Open1Click(Sender: TObject);
  //Open a new NIfTI image
begin
  if not OpenDialog1.Execute then exit;
  LoadDatasetNIFTI(OpenDialog1.FileName,true);
end; //proc Open1Click

function AddExtSearch (var lFilenameX: string): boolean;
//see if we can find a file by adding .nii, .hdr or .nii.gz to filename..
var lFilename: string;
begin
  result := true;
  if fileexists(lFilenameX) then exit;
  lFilename := lFilenameX;
  lFilenameX := lFilename+'.hdr';
  if fileexists(lFilenameX) then
    exit;
  lFilenameX := lFilename+'.nii';
  if fileexists(lFilenameX) then
    exit;
  lFilenameX := lFilename+'.nii.gz';
  if fileexists(lFilenameX) then
    exit;
  result := false;
end;

{$IFDEF Darwin}
function ParentOfAppFolder: string;
var
   lS,lSapp: String;
   lL,lP : integer;
begin
    result := '';
    lS := extractfilepath(paramstr(0));
    lL:= length(lS);
    lP := lL;
    lSapp := '';
    while (lP > 1) and (lSapp <> '.APP') do begin
          if lS[lP] = pathdelim then
             lSapp := ''
          else
              lSapp := upcase(lS[lP])+lSapp;

          dec(lP);
    end;
    if lP < 2 then
       exit;
    lSapp := '';
    for lL := 1 to lP do
        lSapp := lSapp + lS[lL];
    result := ExtractFileDirWithPathDelim(lSapp);
end;
{$ENDIF}

procedure TGLForm1.CheckFilename (var lFilenameX: string);
//find a file even if the file name is missing an extension or does not have a path
var
  lFilename: string;
begin

  lFilename := lFilenameX;
  if AddExtSearch(lFilenameX) then
    exit;
  {$IFDEF Darwin}
  lFilenameX := ParentOfAppFolder + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;
  {$ENDIF}
  lFilenameX := DefaultsDir('') + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;
  lFilenameX := ExtractFileDirWithPathDelim(gPrefs.PrevFilename[1]) + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;
  lFilenameX := ExtractFileDirWithPathDelim(gPrefs.PrevScriptName[1]) + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;

  lFilenameX := ExtractFileDirWithPathDelim(GetCurrentDir) + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;
  //next Aug 2009 - check executable's directory... (same as CurrentDir for Windows, different for Linux)
  lFilenameX := ExtractFileDirWithPathDelim(paramstr(0)) + extractfilename(lFilename);
  if AddExtSearch(lFilenameX) then
    exit;
  //unable to find a match!
  lFilenameX := lFilename;
  lFilename := OpenDialog1.Title;
  OpenDialog1.Filename := (lFilenameX);
  OpenDialog1.Title := 'Please find the file '+extractfilename(lFilenameX);
  if not GLForm1.OpenDialog1.Execute then begin
    OpenDialog1.Title := lFilename;
    exit;
  end;
  OpenDialog1.Title := lFilename;
  lFilenameX :=  GLForm1.OpenDialog1.FileName;
end;

function TGLForm1.LoadDatasetNIFTI(lFilename: string; lStopScript: boolean): boolean;
var
  lFilenameX: string;
begin
  StopTimers;
  if lStopScript then StopScripts;
  gRendering := true;
  lFilenameX := lFilename;
  CheckFilename (lFilenameX);
  result := false;
  gTexture.free;
{$IFDEF ENABLEOVERLAY}
  OverlayForm.Closeoverlays1Click(nil);
{$ENDIF}
  gTexture := TGLTextureHandle.Create;
  InitTexture(gTexture3D);
  {$IFDEF ENABLECUTOUT}CutoutForm.HideBtnClick(nil); //remove any cutouts
  {$ENDIF}
  {$IFDEF ENABLECLIP}
  ClipForm.ClipTrack.Position := 0;
  {$ENDIF}
  SetViewerClipPlane(0);
  M_DrawLUTs := false;
  if not Load_From_NIfTI (gTexture3D,lFilenameX, odd(gGLversionAtleast2)) then begin
      gRendering := false;
     exit;
  end;
  if gTexture3D.MRA then
    MIPMenu.Checked := true
  else
    MIPMenu.Checked := false;
  Add2MRU(gPrefs.PrevFileName,lFilenameX);
  UpdateMRU;
  GLCamera1.Up.SetVector(0,0,1);
  GLDirectOpenGL1.Scale.X := (gTexture3D.Scale[1]);
  GLDirectOpenGL1.Scale.Y := (gTexture3D.Scale[2]);
  GLDirectOpenGL1.Scale.Z := (gTexture3D.Scale[3]);
  Frame.Matrix := GLDirectOpenGL1.Matrix;
  //finally, set the reset flag so the new image will be loaded
  M_Refresh := TRUE;
  //set a Sagittal view.
  // Note we do not scale by GLCamera.DistanceToTarget
  // As the user may have zoomed near or far from a previous object...
  gGLcoords.X := kInitialDx;
  gGLcoords.Y := 0;
  gGLcoords.Z := 0;
  GLCamera1.Position := (gGLcoords);
  //point camera toward origin at 0,0,0
  // probably not necessary as camera never points elsewhere
  gGLcoords.X := 0;//-lV.X;
  gGLcoords.Y := 0;//-lV.Y;
  gGLcoords.Z := 0;//-lV.Z;
  GLCamera1.Direction := (gGLcoords);
  //Sagittal1Click(nil);
  gRendering := false;
  GLSceneViewer1.refresh;
  result := true;
end; //LoadDatasetNIFTI

procedure TGLForm1.TimerTimer(Sender: TObject);
var
  lFPS,lSign: single;
begin
  Timer.enabled := GLCadencer.enabled;
  lFPS := GLSceneViewer1.FramesPerSecond;
  if gAnimation_Rotation < 0 then
    lSign := -1
  else
    lSign := 1;
  Caption := GLSceneViewer1.FramesPerSecondText;
  GLSceneViewer1.Buffer.ResetPerformanceMonitor ;
  if Timer.Tag < 2 then begin //only adjust rotation speed over the first couple seconds
     //otherwise, rotation speed can appear to jitter
     Timer.Tag := Timer.Tag + 1;
     if (lFPS > 10) then begin
        gAnimation_Rotation := lSign*90/lFPS
     end else
         gAnimation_Rotation := lSign*kAnimation_Rotation;
  end;
end;

procedure TGLForm1.GLCadencerProgress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
   GLCamera1.MoveAroundTarget (0, gAnimation_Rotation) ;
   GLSceneViewer1.Invalidate;
end;

procedure TGLForm1.About2Click(Sender: TObject);
begin
 // SavePicture('c:\junk.jpg');exit;
{$IFDEF ENABLEABOUT}
  AboutForm.SizeLabel.caption := 'XxYxZxBytes = '+inttostr(gTexture3D.Dim[1])+'x'
    +inttostr(gTexture3D.Dim[2])+'x'+inttostr(gTexture3D.Dim[3]);
  AboutForm.Show;
{$ELSE}
showmessage('About box not enabled.');
{$ENDIF}
end;

procedure TGLForm1.AnimateMenuClick(Sender: TObject);
begin
    gAnimation_Rotation := kAnimation_Rotation;
    //   if (ssShift in KeyDataToShiftState(vk_Shift)) then
    GLCadencer.SleepLength := -1;
  GLCadencer.Enabled := not GLCadencer.Enabled;
  Timer.Tag := 0; //allows us to adjust rotation speed over the first few seconds
  Timer.Enabled := GLCadencer.Enabled;
end;

{$IFDEF FPC}
const
     kBorderHt = 30;
     kBorderWid = 10;
{$ELSE}
const
     kBorderHt = 0;
     kBorderWid = 0;
{$ENDIF}
procedure TGLForm1.AdjustFormPos (var lForm: TForm);
const
{$IFDEF FPC}
kExtra = 8;
{$ELSE}
kExtra = 0;
{$ENDIF}
var
  lPos: integer;
  lVidX,lVidY,lLeft,lTop: integer;
begin
  ScreenRes(lVidX,lVidY);
  lPos := lForm.Tag;
  if odd(lPos) then begin//form on left
    lLeft := GLForm1.Left-lForm.Width-kBorderWid;
    if lLeft < 0 then //try putting the form on the right
       lLeft := GLForm1.Left+GLForm1.Width+kExtra; //form on right
  end else begin
    lLeft := GLForm1.Left+GLForm1.Width+kExtra;//-default: right
    if ((lLeft+ lForm.Width) > lVidX) then
       lLeft := GLForm1.Left-lForm.Width-kBorderWid; //try on right
  end;
  if lPos < 3 then begin //align with top
    lTop := GLForm1.Top; //default - align with top
    if lTop < 0 then //backup - top of screen
       lTop := 0;
  end else begin
    lTop := GLForm1.Top+GLForm1.Height-lForm.Height+kBorderHt; //default - align with bottom
    if ((lTop+lForm.Height) > lVidY) then
       lTop := GLForm1.Top; //backup - align with top
    if lTop < 0 then
       lTop := 0;
  end;
  if (lPos = 0) or ((lLeft+ lForm.Width) > lVidX) or (lLeft < 0)
    or (lTop < 0) or ((lTop+lForm.Height) > lVidY) then
    lForm.Position := poScreenCenter
  else begin
    lForm.Position := poDesigned;
 // caption := inttostr(lVidx)+'x'+inttostr(lVidY)+'  c '+inttostr(GLForm1.left)+' L'+inttostr(lLeft);

    lForm.Left := lLeft;
    lForm.Top := lTop;
  end;
end;

procedure TGLForm1.Cutout1Click(Sender: TObject);
begin
{$IFDEF ENABLECUTOUT}
    if CutoutForm.Visible then
    CutoutForm.Close
  else begin
    AdjustFormPos(TFOrm(CutoutForm));
    CutoutForm.Show;
  end;
{$ELSE}
  showmessage('Cutout not in this implementation.');
{$ENDIF}
end;

procedure TGLForm1.ClipMenuClick(Sender: TObject);
begin
  {$IFDEF ENABLECLIP}
  if ClipForm.Visible then
    ClipForm.Close
  else begin
    AdjustFormPos(TFOrm(ClipForm));
    ClipForm.Show;
  end;
  {$ELSE}
    showmessage('Clipping not supported in this compilation');
  {$ENDIF}
end;

procedure TGLForm1.FrameMenuClick(Sender: TObject);
begin
  {$IFDEF FPC} {FrameMenu.Checked := not FrameMenu.Checked;} {$ENDIF}
  Frame.Visible := FrameMenu.Checked;
  GLSceneViewer1.Invalidate;
end;

procedure TGLForm1.PerspectiveMenuClick(Sender: TObject);
  var
Shift: TShiftState;
MousePos: TPoint;
Handled: Boolean;
begin
    {$IFDEF FPC} {PerspectiveMenu.Checked := not PerspectiveMenu.Checked;} {$ENDIF}
  gPrefs.Perspective := PerspectiveMenu.checked;
  if gPrefs.Perspective then
    GLCamera1.CameraStyle := csPerspective
  else
    GLCamera1.CameraStyle := csOrthogonal;
  FormMouseWheel(nil,Shift, 0, MousePos, Handled);
    GLSceneViewer1.Invalidate;
end;

procedure TGLForm1.ScreenCaptureProgress(Sender: TObject; const deltaTime,
  newTime: Double);
  //save an image at this position and rotate to next position in animation
var
  lStr: string;
begin
  inc(Snapshot);
  lStr := inttostr(SnapShot);
  if length(lStr) < 2 then
    lStr := '0'+lStr;//pad 1..9 to be 01..09 so order is correct in string sorting...
  lStr := ChangeFileExt(SaveDialog1.FileName,lStr+'.bmp');
  SavePicture(lStr);
  //GLSceneViewer1.Buffer.CreateSnapShotBitmap.SaveToFile(lStr);
  GLCamera1.MoveAroundTarget (0, gAnimation_Rotation) ;
  GLSceneViewer1.Invalidate;
  if SnapShot = nSnapShots then
    ScreenCapture.Enabled := false;
end; //proc ScreenCaptureProgress

function KToVoxel(lK, lRange: integer): integer;
//takes a value 0..1000 representing 0..100%, returns proportion of dimension
begin
  if lK < 0 then
    result := 0
  else
    result := round((lK/1000) * lRange);
  if result >= lRange then
    result := lRange - 1;
end;

procedure SortInt (var lLo,lHi: integer);
var
  lSwap: integer;
begin
  if lLo <= lHi then exit;
  lSwap := lLo;
  lLo := lHi;
  lHi := lSwap;
end;

procedure Bound(var lLo,lHi: integer; lDimSize: integer);
//ensure values are inside volume
begin
    if lLo < 1 then
      lLo := 1;
    if lHi < 1 then
      lHi := 1;
    if lLo > lDimSize then
      lLo := lDimSize;
    if lHi > lDimSize then
      lHi := lDimSize;
end; //proc Bound

Procedure TGLForm1.CreateCutout;
{$IFNDEF ENABLECUTOUT}
begin
    //ignore
    
end;
{$ELSE}
//removes a sector from the image to give a cut-away-view
Var
  lCreaseLoop,lSliceOffset,lColorBytes,lColorBytesMinusOne,lTexelBytes,
  lZi,lYi,lXi,L,I,X,Y,Z,lX,lY,lZ,lX2,lY2,lZ2,Index,lSliceSz: integer;
begin
//exit;      //cutx
  lTexelBytes := gTexture3D.BytesPerVoxel; //e.g. RGBA=4, Luminance+Alpha=2
  lColorBytes := lTexelBytes-1;//e.g. RGBA = 3 color bytes, Luminance+Alpha only has 1 (luminance)
  lColorBytesMinusOne := lColorBytes -1;
   lX := CutoutForm.XTrackbar.position;
   lY := CutoutForm.YTrackbar.position;
   lZ := CutoutForm.ZTrackbar.position;
   lX2 := CutoutForm.X2Trackbar.position;
   lY2 := CutoutForm.Y2Trackbar.position;
   lZ2 := CutoutForm.Z2Trackbar.position;
   if (lX=lX2) and (lY=lY2) and (lZ = lZ2) then exit;
   if (lX=0) and (lX2 = 0) then exit;
   if (lY=0) and (lY2 = 0) then exit;
   if (lZ=0) and (lZ2 = 0) then exit;
   //scale units to object
   lX := KToVoxel(lX,gTexture3D.FiltDim[1]);
   lY := KToVoxel(lY,gTexture3D.FiltDim[2]);
   lZ := KToVoxel(lZ,gTexture3D.FiltDim[3]);
   lX2 := KToVoxel(lX2,gTexture3D.FiltDim[1]);
   lY2 := KToVoxel(lY2,gTexture3D.FiltDim[2]);
   lZ2 := KToVoxel(lZ2,gTexture3D.FiltDim[3]);
   SortInt(lX,lX2);
   SortInt(lY,lY2);
   SortInt(lZ,lZ2);
   if ((lX2-lX)<1) or ((lY2-lY)<1) or ((lZ2-lZ)<1) then
    exit;
   lSliceSz := gTexture3D.FiltDim[2] * gTexture3D.FiltDim[1];
   //this optimized code reduces the number of multiplications to a minimum, but keeps more variables in flight
   For Z := lZ To lZ2 Do Begin { For Z}
      lZi := Z * lSliceSz* lTexelBytes; //unroll loop - only once per slice
      For Y := lY To lY2 Do Begin { For Y}
        lYi := Y * gTexture3D.FiltDim[1]* lTexelBytes;
        lXi := lZi + lYi + (lX * lTexelBytes)+lColorBytes;
          For X := lX To lX2 Do Begin { For X}
              Index := lXi;
              gTexture3D.FiltImg^[Index] := 0;//Set Alpha to invisible
              lXi := lXi + lTexelBytes;
            End; { For X}
        End; { For Y}
   End; { For Z}
    //next: draw creases
    //creases are drawn further out by one pixel in each dimension
    //opacity will show these as slightly darkened lines
   //caption := (inttostr(lZ)+' '+inttostr(lZ2));
 for lCreaseLoop := 1 to 2 do begin
    dec(lX);
    dec(lY);
    dec(lZ);
    inc(lX2);
    inc(lY2);
    inc(lZ2);
    bound(lX,lX2,gTexture3D.FiltDim[1]);
    bound(lY,lY2,gTexture3D.FiltDim[2]);
    bound(lZ,lZ2,gTexture3D.FiltDim[3]-1);
    //X crease - four lines running left right
    For L := 1 to 4 do begin
      case L of
        1,2: Z := lZ;
      else
        Z := lZ2;
        end;
      case L of
        1,3: Y := lY;
      else
        Y := lY2;
      end;
      lSliceOffset := ((Z-1) * lSliceSz) + ((Y-1) * gTexture3D.FiltDim[1]);
      For X := lX To lX2 Do Begin { For X}
              Index := (lSliceOffset + X)*lTexelBytes;
              For I := 0 to lColorBytesMinusOne do
                gTexture3D.FiltImg^[Index + I] := 0;//Set RGB to black
      End; { For X}
    end; //for each L - draw lines along X axis
    //Y crease - Four lines in the anterior-posterior direction
    For L := 1 to 4 do begin
      case L of
        1,2: Z := lZ;
      else
        Z := lZ2;
        end;
      case L of
        1,3: X := lX;
      else
        X := lX2;
      end;
      lSliceOffset := ((Z-1) * lSliceSz) + X;
      For Y := lY To lY2 Do Begin
              Index := (lSliceOffset + ((Y-1) * gTexture3D.FiltDim[1]))*lTexelBytes;
              For I := 0 to lColorBytesMinusOne do
                gTexture3D.FiltImg^[Index + I] := 0;//Set RGB to black
      End; // For Y
    end; //for each L - draw lines along X axis
    //Z crease - four lines running in the head-foot direction
    For L := 1 to 4 do begin
      case L of
        1,2: Y := lY;
      else
        Y := lY2;
        end;
      case L of
        1,3: X := lX;
      else
        X := lX2;
      end;
      lSliceOffset := ((Y-1) * gTexture3D.FiltDim[1])+X;
      For Z := lZ To lZ2 Do Begin { For Z}
              Index := (lSliceOffset+((Z-1) * lSliceSz) )*lTexelBytes;
              For I := 0 to lColorBytesMinusOne do
                gTexture3D.FiltImg^[Index + I] := 0;//Set RGB to black
      End; // For Z
    end; //for each L - draw lines along X axis
 end; //CreaseLoop
end;//proc CreateCutout
{$ENDIF}
(*procedure TGLForm.DoubleSize;
//use linear interpolation to create supersampled image
// typical trilinear filtering requires finding mean contribution of 8 nearest parent voxels
//     e.g. eight multiply adds per output voxel
//     however, this uses the special case of doubling the volume size
//     every parent voxel is turned into eight children -
//      one child is identical to the parent, the other seven are half the sum of two neighbors
//      this allows addition and shr 1 instead of multiplies or division
var
  lSliceStart,lByte,
  lIn,lZ,lY,lX,lOutVolBytes,lOutSliceBytes,lAvg,lLineStart,lLineBytes: integer;
  lOutVol: bytep0;
begin
  with gTexture3D do begin
    if (Dim[1] <3) or (Dim[2] < 3) or (Dim[3]< 3) or (BytesPerVoxel < 2) then
      exit;
    FiltDim[1] := Dim[1] shl 1;// shl 1;
    FiltDim[2] := Dim[2] shl 1;// shl 1;
    FiltDim[3] := Dim[3] shl 1;// shl 1;
    //lInBytes := Dim[1]*Dim[2]*Dim[3]* BytesPerVoxel;
    lOutSliceBytes := FiltDim[1]*FiltDim[2]* BytesPerVoxel;
    lOutVolBytes := FiltDim[3] * lOutSliceBytes;
    lLineBytes := FiltDim[1] * BytesPerVoxel;
    //Copy original FiltImg to OutVol, than create enlarged FiltImg
    GetMem(lOutVol,Dim[1]*Dim[2]*Dim[3]* BytesPerVoxel);
    Move (FiltImg^,lOutVol^, Dim[1]*Dim[2]*Dim[3]* BytesPerVoxel);
    SetLengthB(FiltImg,lOutVolBytes);
    fillchar(FiltImg^,lOutVolBytes,0);
    //1: raw values go into odd slices, odd columns, odd rows - first one of eight
    lIn := 0;
    for lZ := 1 to (Dim[3]) do begin //only odd slices
      lSliceStart := ((lZ-1) * lOutSliceBytes) shl 1; //shl 1 - skip even slices
      for lY := 1 to (Dim[2]) do begin //only odd rows
        lLineStart := (((lY-1) * lLineBytes) shl 1)+lSliceStart;//shl1 skip even rows
        for lX := 1 to (Dim[1]) do begin //only odd columns
          for lByte := 0 to (BytesPerVoxel-2) do begin
            FiltImg^[lLineStart+lByte] := lOutVol^[lIn];
            inc(lIn);
          end;
          FiltImg^[lLineStart+BytesPerVoxel-1] := lOutVol^[lIn] shr 1; //reduce alpha by 50%
          inc(lIn);
          inc(lLineStart,BytesPerVoxel+BytesPerVoxel);//twice: skip even column
        end;//for X
      end;//for Y
    end;//for Z
    //Finally - transfer new values...
    FreeMem(lOutVol);
   //2: fill in even slices: only odd columns, odd rows - second of eight voxels
    for lZ := 1 to (Dim[3] -1) do begin //only odd slices
      lSliceStart := (((lZ-1) * lOutSliceBytes) shl 1) + lOutSliceBytes; //shl 1 - skip even slices
      for lY := 1 to (Dim[2] ) do begin //only odd rows
        lLineStart := (((lY-1) * lLineBytes) shl 1)+lSliceStart;//shl1 skip even rows
        for lX := 1 to (Dim[1]) do begin //only odd columns
          for lByte := 0 to (BytesPerVoxel-1) do
            FiltImg^[lLineStart+lByte] := (FiltImg^[lLineStart+lByte-lOutSliceBytes]+FiltImg^[lLineStart+lByte+lOutSliceBytes]) shr 1;//FiltImg^[lIn];
          inc(lLineStart,BytesPerVoxel+BytesPerVoxel);//twice: skip even column
        end;//for X
      end;//for Y
    end;//for Z
    //3: fill in even rows: only odd columns   - two more voxels per eight
    for lZ := 1 to (FiltDim[3] -1) do begin //all slices
      lSliceStart := (lZ-1) * lOutSliceBytes;
      for lY := 1 to (Dim[2]-1) do begin //fill even rows
        lLineStart := (((lY-1) * lLineBytes) shl 1)+lLineBytes+lSliceStart;//shl1 skip even rows
        for lX := 1 to (Dim[1]) do begin //only odd columns
          for lByte := 0 to (BytesPerVoxel-1) do
            FiltImg^[lLineStart+lByte] := (FiltImg^[lLineStart+lByte-lLineBytes]+FiltImg^[lLineStart+lByte+lLineBytes]) shr 1;//FiltImg^[lIn];
          inc(lLineStart,BytesPerVoxel+BytesPerVoxel);//twice: skip even column
        end;//for X
      end;//for Y
    end;//for Z
    //4: fill even columns - final 4 of 8 voxels
    for lZ := 1 to (FiltDim[3] -1) do begin //all slices
      lSliceStart := (lZ-1) * lOutSliceBytes;
      for lY := 1 to (FiltDim[2]-1) do begin //all rows
        lLineStart := ((lY-1) * lLineBytes) +lSliceStart+BytesPerVoxel;//shl1 skip even rows
        for lX := 1 to (Dim[1]-1) do begin //fill even columns
          for lByte := 0 to (BytesPerVoxel-1) do
            FiltImg^[lLineStart+lByte] := (FiltImg^[lLineStart+lByte-BytesPerVoxel]+FiltImg^[lLineStart+lByte+BytesPerVoxel]) shr 1;//FiltImg^[lIn];
          inc(lLineStart,BytesPerVoxel+BytesPerVoxel);//twice: skip even column
        end;//for X
      end;//for Y
    end;//for Z
  end; //with Texture
end;//proc DoubleSize *)

function AdjustTransparencyRGBA (var lTexture: TTexture): boolean;
//adjust the transpareny of an image that has RGBA as source
//with other image formats, this is done on the UnFiltRGBAImg, because there is a raw image in the native data format
//for RGBA, we need to manipulate the FiltImg
var
  lnVox,lPos,lC: integer;
  lCLUT: TLUT;
begin
  result := false;
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if lnVox < 1 then
    exit;
  if (lTexture.RawUnscaledImg16 <> nil) or  (lTexture.RawUnscaledImg32 <> nil) or (lTexture.RawUnscaledImg8 <> nil) then
    exit;
  Move (gTexture3D.RawUnscaledImgRGBA^,gTexture3D.FiltImg^, lnVox *  gTexture3D.BytesPerVoxel);
  GenerateLUT(gCLUTrec, lCLUT);
  lPos := 0;
  for lC := 1 to lnVox do begin
    gTexture3D.FiltImg^[lPos+3] := lCLUT[gTexture3D.FiltImg^[lPos+1]].rgbReserved;
    lPos := lPos + 4;
  end;
  result := true;
end; //proc AdjustTransparency

Procedure TGLForm1.Calculate_Transfer_Function;
//copies input_texture to output_texture
//adjusts Alpha to account for Invisible Threshold and clipping planes
var
 lCLUT: TLUT;
begin
  if gTexture3D.FiltImg = nil then
        exit;
  if not AdjustTransparencyRGBA(gTexture3D) then begin
        GenerateLUT(gCLUTrec, lCLUT);
        rescale2RGB (gTexture3D,gCLUTrec.min,gCLUTrec.max,lCLUT); // see CLUT.pas
  end;
{$IFDEF ENABLEOVERLAY}
  OverlayForm.BlendOverlays(gTexture3D);
{$ENDIF}
  CreateCutout;
  //Caption := inttostr(random(888))+' '+ inttostr(gOpenOverlays);
end; //proc Calculate_Transfer_Function




Procedure TGLForm1.GLDirectOpenGL1Render(Sender: TObject; var rci: TRenderContextInfo);
Var
  lStr,lVStr: string;
  depthplanes,i : Integer;
  step : Single;
  z : Single;
  mat : TMatrix;
  v : TVector;
  vx, vy, vz : TAffineVector;
Begin
//exit;     //abba22
  if gRendering then begin
    UpdateTimer.Enabled := true;
    exit;
  end;
  //caption := inttostr(random(222));
  gRendering := true;
  if gGLversionAtleast2 < 0 then begin
    ReadImplementationProperties;
    gGLversionAtleast2 := 0; //assume not suitable, but now it is checked
    lStr := glGetString(GL_VERSION);
    lVStr := glGetString(GL_VENDOR);
    GLForm1.Caption := 'OpenGL '+lStr+' '+lVStr;
    if (length(lStr) < 1) then
      i := 0
    else begin
      //lCh := lStr[1];//first character of string
      if lStr[1] in ['0','1'..'9'] then
        i := strtoint(lStr[1])
      else
        i := 0;
    end;
    if (gPrefs.IntelWarning) and  (length(lStr) > 0) and (upcase(lVStr[1]) = 'I') then begin
      showmessage('You are using an Intel graphics card - this is unlikey to support volume rendering. If your laptop supports hybrid graphics, switch to the discrete ATI/NVidia graphics card.');
      gPrefs.RenderQuality := kNoRender;
    end else if  gPrefs.RenderQuality = kNoRender then begin
        if OKMsg('Do you want to enable rendering?') then
          gPrefs.RenderQuality := kNormalRender;
    end;
    //before OpenGL2, the textures were constrained to powers of two
   (* if not  GL_EXT_texture3D  then
          showmessage('Graphic card does not support 3D textures (OpenGL extension GL_EXT_texture3D).')
    else if i < 2 then begin
          showmessage('Warning: this graphics card may not support 3D textures (obsolete OpenGL support). Usually this requires upgrading your graphics card. For some Sony laptops, you could try switching from ''Stamina'' to ''Speed'' mode.');
          gGLversionAtleast2 := 1;
    end else
      gGLversionAtleast2 := 1;
                              *)
      gGLversionAtleast2 := 2;
    if gGLversionAtleast2 > 0 then begin
      //NPOT was added in the latest OpenGL1x.pas svn file.
      //before this, you could try GL_NV_texture_rectangle
      //but this did not detect functions on Radeons
      if (GL_ARB_texture_non_power_of_two) then
       gGLversionAtleast2 := 2;

      if LoadParamStr (false) then begin
        AutoRunTimer.Enabled := true;
        gRendering := false;
        exit;
      end else if Fileexists(gPrefs.PrevFilename[1]) then begin
          OpenDialog1.InitialDir:= extractfiledir(gPrefs.PrevFilename[1]);
          SaveDialog1.initialDir := OpenDialog1.InitialDir;
        LoadDatasetNIFTI(gPrefs.PrevFilename[1],true)
      end else begin
          OpenDialog1.InitialDir:= GetCurrentDir;
          LoadDatasetNIFTI('ch256',true);
          if Fileexists(gPrefs.PrevFilename[1]) then begin
             OpenDialog1.InitialDir:= extractfiledir(gPrefs.PrevFilename[1]);
             if GZext(gPrefs.PrevFilename[1]) then //only open nii.gz, not just .gz
                FillMRU (gPrefs.PrevFilename, ExtractFileDirWithPathDelim(gPrefs.PrevFilename[1]),'.nii.gz',true)
             else
                FillMRU (gPrefs.PrevFilename, ExtractFileDirWithPathDelim(gPrefs.PrevFilename[1]),extractfileext(gPrefs.PrevFilename[1]),true);
            UpdateMRU;
          end;
          SaveDialog1.initialDir := OpenDialog1.InitialDir;
       end;
    end;//GLversion tested
  end; //if gGLversionAtleast2 < 0
  if (gGLversionAtleast2 < 1) or (gTexture3D.Dim[1] < 2) or (gTexture3D.Dim[2] < 2) or (gTexture3D.Dim[3] < 2)  then begin
        gRendering := false;
      exit;
  end;
  If (gTexture.Handle = 0)  Then Begin
      Assert (GL_EXT_texture3D, 'Graphic card does not support 3D textures.');
      //Use PROXY to see if video card can support a texture...
      //http://www.opengl.org/resources/faq/technical/texture.htm
      //glTexImage3D(GL_PROXY_TEXTURE_2D, level, internalFormat,  width, height, border, format, type, NULL);
     //Note the pixels parameter is NULL, because OpenGL doesn't load texel data when the target parameter is GL_PROXY_TEXTURE_2D. Instead, OpenGL merely considers whether it can accommodate a texture of the specified size and description. If the specified texture can't be accommodated, the width and height texture values will be set to zero. After making a texture proxy call, you'll want to query these values as follows:
      glTexImage3D   (GL_PROXY_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], 0, gTexture3D.DataType, GL_UNSIGNED_BYTE, nil);
     glGetTexLevelParameteriv(GL_PROXY_TEXTURE_3D, 0, GL_TEXTURE_WIDTH, @i);
     if i < 1 then begin
         showmessage('Your video card is unable to load an image that is this large.');
         exit;
     end;
     //end of PROXY
      If (gTexture.Handle = 0) then
        gTexture.AllocateHandle;
      glBindTexture (GL_TEXTURE_3D, gTexture.Handle);
      glTexParameterf (GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_CLAMP);
      glTexParameterf (GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_CLAMP);
      glTexParameterf (GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_CLAMP);
      glTexParameteri (GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      glTexParameteri (GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      //OSX glTexImage3D not glTexImage3DEXT
      {$IFDEF Darwin}
      glTexImage3D   (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], 0, gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar(gTexture3D.FiltImg));
      {$ELSE}
      glTexImage3DExt   (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], 0, gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar(gTexture3D.FiltImg));
      {$ENDIF}
      //glTexImage3DEXT    (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], 0, gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar(gTexture3D.FiltImg));
      //glTexImage3DEXT    (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.Dim[1], gTexture3D.Dim[2], gTexture3D.Dim[3], 0, gTexture3D.Data_Type, GL_UNSIGNED_BYTE, PChar (gTexture3D.OData));
  End; //new texture
  //exit;
  If M_Refresh = TRUE Then Begin //if texture changed due to loading new image, adjusting surface threshold, changing cutout
      M_Refresh := FALSE;
      Calculate_Transfer_Function;
      //glTexImage3D    (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.Dim[1], gTexture3D.Dim[2], gTexture3D.Dim[3], 0, gTexture3D.Data_Type, GL_UNSIGNED_BYTE, PChar (gTexture3D.OData));
      //glTexImage3DEXT    (GL_TEXTURE_3D, 0, GL_RGBA8, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], 0, gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar(gTexture3D.FiltImg));
      //OSX only supports glTexSubImage3D not glTexSubImage3DExt
      //Intel cards on Windows only support glTexSubImage3D not glTexSubImage3DExt
      {$IFDEF FPC}
              {$IFDEF Darwin}
              glTexSubImage3D (GL_TEXTURE_3D, 0, 0, 0, 0, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar (gTexture3D.FiltImg));
              {$ELSE} //The stable release of Lazarus GLScene for Windows only includes the Ext version...
              glTexSubImage3DExt (GL_TEXTURE_3D, 0, 0, 0, 0, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar (gTexture3D.FiltImg));
              {$ENDIF}
      {$ELSE} //not FPC - Intel cards on Windows prefer glTexSubImage3D over glTexSubImage3DExt
      glTexSubImage3D (GL_TEXTURE_3D, 0, 0, 0, 0, gTexture3D.FiltDim[1], gTexture3D.FiltDim[2], gTexture3D.FiltDim[3], gTexture3D.DataType, GL_UNSIGNED_BYTE, PChar (gTexture3D.FiltImg));
      {$ENDIF}
  End; //if M_refresh

  if gDrawMosaicStr <> '' then begin
    if gDrawMosaicStr = 'x' then begin
      Frame.Visible := FrameMenu.Checked;
      GLSceneViewer1.Align := alClient;
      gDrawMosaicStr := '';
      //gRendering := false;

      //exit;
    end else begin
      Frame.Visible := false;
      //MosaicPrefsForm.caption := gDrawMosaicStr;  ///222
      mosaicGL (gDrawMosaicStr,gTexture3D,depthplanes,i,false,rci);
      //DrawTextX(rci);
      if gPrefs.Colorbar then
        DrawCLUT( gPrefs.ColorBarPos,0.01,rci,GLForm1.GLWindowsBitmapFont1, gPrefs,GLForm1.GLSceneViewer1);
      gDrawMosaicStr := 'x';
        gRendering := false;
      exit;
    end;
  end;
  //glform1.caption := inttostr(random(888));

  if gPrefs.OrthoSliceView then begin
    Frame.Visible := false;
    ShowOrthoSlice(rci);
      if gPrefs.Colorbar then
        DrawCLUT( gPrefs.ColorBarPos,0.01,rci,GLForm1.GLWindowsBitmapFont1, gPrefs,GLForm1.GLSceneViewer1);
    gRendering := false;
    exit;
  end;

  // reset matrix - glLoadIdentity();
  glPushAttrib (GL_ENABLE_BIT);
  glPushMatrix;
  glEnable (GL_BLEND);
  //glShadeModel(GL_SMOOTH);
  //integration can select brightest voxel that the ray traverses [MIP]
  // or the data can be integrated based on alpha level [trnanslucent slices]
  if MIPMenu.checked  then
      glBlendEquationEXT(GL_MAX_EXT)
  else
      glBlendEquationEXT(GL_FUNC_ADD_EXT);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDisable (GL_CULL_FACE);
  glDisable (GL_LIGHTING);
  //glEnable (GL_LIGHTING);
  glTexGenf (GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGenf (GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGenf (GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  SetVector (v, XVector, 0.5);
  glTexGenfv (GL_S, GL_OBJECT_PLANE, @v);
  SetVector (v, YVector, 0.5);
  glTexGenfv (GL_T, GL_OBJECT_PLANE, @v);
  SetVector (v, ZVector, 0.5);
  glTexGenfv (GL_R, GL_OBJECT_PLANE, @v);
  glEnable (GL_TEXTURE_GEN_S);
  glEnable (GL_TEXTURE_GEN_T);
  glEnable (GL_TEXTURE_GEN_R);
  //without clip planes, voxels on the edges bleed into the periphery...
  glClipPlane(GL_CLIP_PLANE0, @clip0);
  glClipPlane(GL_CLIP_PLANE1, @clip1);
  glClipPlane(GL_CLIP_PLANE2, @clip2);
  glClipPlane(GL_CLIP_PLANE3, @clip3);
  glClipPlane(GL_CLIP_PLANE4, @clip4);
  glClipPlane(GL_CLIP_PLANE5, @clip5);
  glEnable(GL_CLIP_PLANE0);
  glEnable(GL_CLIP_PLANE1);
  glEnable(GL_CLIP_PLANE2);
  glEnable(GL_CLIP_PLANE3);
  glEnable(GL_CLIP_PLANE4);
  glEnable(GL_CLIP_PLANE5);
  //finally, draw object
  glBindTexture (GL_TEXTURE_3D, gTexture.Handle);
if gPrefs.RenderQuality = kNORender then begin //draw slice sections instead of rendering...
    //glColor4f (1, 1, 1,1);
  //glBlendFunc (GL_ONE,GL_ZERO{GL_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA});
  glBlendFunc (GL_ONE,GL_ZERO);
  glEnable (GL_TEXTURE_3D);
  // glMatrixMode(GL_MODELVIEW);
  z := 0; //slice
  glBegin (GL_QUADS);
  //X constant : sagittal
      glVertex3f (z, 1, 1);
      glVertex3f (z, -1, 1);
      glVertex3f (z,-1,-1);
      glVertex3f (z, 1, -1);
  //Y constant : coronal
      glVertex3f (1, z, 1);
      glVertex3f ( -1,z, 1);
      glVertex3f (-1,z,-1);
      glVertex3f (1,z, -1);
  //Z constant : axial
      glVertex3f (1, 1, z);
      glVertex3f (-1, 1, z);
      glVertex3f (-1,-1, z);
      glVertex3f (1, -1, z);
  glEnd;
end else begin //not 2D planes ... next 3D rendering
  depthplanes := round(sqrt(sqr(gTexture3D.FiltDim[1])+sqr(gTexture3D.FiltDim[2])+sqr(gTexture3D.FiltDim[3])));
  if gPrefs.RenderQuality = kFastRender then
    depthplanes := depthplanes div 2;//round(sqrt(sqr(gTexture3D.FiltDim[1])+sqr(gTexture3D.FiltDim[2])+sqr(gTexture3D.FiltDim[3])));
  if depthplanes < 1 then
    depthplanes := 1;
  glEnable (GL_TEXTURE_3D);
  glGetFloatv (GL_MODELVIEW_MATRIX, @mat);
  vx [0] := mat [0] [0];
  vy [0] := mat [0] [1];
  vz [0] := mat [0] [2];
  vx [1] := mat [1] [0];
  vy [1] := mat [1] [1];
  vz [1] := mat [1] [2];
  vx [2] := mat [2] [0];
  vy [2] := mat [2] [1];
  vz [2] := mat [2] [2];
  ScaleVector (vx, DIAGONAL_LENGTH * 0.5 / VectorLength (vx));
  ScaleVector (vy, DIAGONAL_LENGTH * 0.5 / VectorLength (vy));
  ScaleVector (vz, DIAGONAL_LENGTH * 0.5 / VectorLength (vz));
  step := DIAGONAL_LENGTH / depthplanes;
  z := -DIAGONAL_LENGTH / 2;
  glBegin (GL_QUADS);
  glColor4f (gObjRed, gObjGreen, gObjBlue, 1.0);
    For i := 0 To depthplanes - 1 Do Begin
      //next line commented out...surface normals not used for volume rendering
      //glNormal3f (-GLCamera.AbsoluteVectorToTarget [0], -GLCamera.AbsoluteVectorToTarget [1], -GLCamera.AbsoluteVectorToTarget [2]);
      glVertex3f (vx [0] + vy [0] + vz [0] * z, vx [1] + vy [1] + vz [1] * z, vx [2] + vy [2] + vz [2] * z);
      glVertex3f (-vx [0] + vy [0] + vz [0] * z, -vx [1] + vy [1] + vz [1] * z, -vx [2] + vy [2] + vz [2] * z);
      glVertex3f (-vx [0] - vy [0] + vz [0] * z, -vx [1] - vy [1] + vz [1] * z, -vx [2] - vy [2] + vz [2] * z);
      glVertex3f (vx [0] - vy [0] + vz [0] * z, vx [1] - vy [1] + vz [1] * z, vx [2] - vy [2] + vz [2] * z);
      z := z + step;
    End;
  glEnd;
end; //Rendering
  if MIPMenu.checked  then //return to normal, otherwise overlay text appears odd..
      glBlendEquationEXT(GL_FUNC_ADD_EXT);

  glPopMatrix;
  glPopAttrib;

  if gPrefs.Colorbar then
        DrawCLUT( gPrefs.ColorBarPos,0.01,rci,GLForm1.GLWindowsBitmapFont1, gPrefs,GLForm1.GLSceneViewer1);
  gRendering := false;


End; //proc GLDirectOpenGLRender



procedure TGLForm1.RotationAnimation1Click(Sender: TObject);
begin
    gAnimation_Rotation := -5;
    GLCadencer.SleepLength := -1;
  GLCadencer.Enabled := true;//not GLCadencer.Enabled;
  Timer.Enabled := GLCadencer.Enabled;
end;

function TGLForm1.VectorCameraDx (lX,lY,lZ: single): single;
//Squared Distance between two points - use SqRt on result for actual distance...
begin
    gGLcoords2 := GLForm1.GLCamera1.Position;
    gGLcoords2.Normalize;
    result := sqr(lX-gGLcoords2.X)+sqr(lY-gGLcoords2.Y)+sqr(lZ-gGLcoords2.Z);
end;

(*procedure sph2cartRad(THETA,PHI,R: single; var X,Y,Z: single);
//convert spherical AZIMUTH,ELEVATION,RANGE to Cartesion
//see Matlab's [x,y,z] = sph2cart(THETA,PHI,R)
// reverse with cart2sph
begin
  x := r * cos(Phi)*cos(Theta);
  y := r * cos(Phi)*sin(Theta);
  z := r * sin(Phi);
end;*)

function sgn (a : real) : real;
begin
  if a < 0  then  sgn := -1
            else  sgn :=  1;
end;

function atan2 (y, x : real) : real;
begin
  if x > 0       then  atan2 := arctan (y/x)
  else if x < 0  then  atan2 := arctan (y/x) + pi
  else                 atan2 := pi/2 * sgn (y);
end;

procedure cart2sph(var Azimuth,Elevation {,R}: single; var lV: TGLCoordinates);
//convert spherical AZIMUTH,ELEVATION,RANGE to Cartesion
//see Matlab's [x,y,z] = sph2cart(THETA,PHI,R)
// reverse with cart2sph
begin
 Azimuth := atan2(lV.y,lV.x);
 Elevation := atan2(lV.z,sqrt(Sqr(lV.x)+Sqr(lV.Y)) );
 Azimuth := radtodeg(Azimuth)+90;
 Elevation := radtodeg(Elevation);
 //R := sqrt(sqr(lV.X)+sqr(lV.Y)+sqr(lV.Z)); //distance by pythagorean theorem
end;

procedure TGLForm1.ReportAziElev;
var Azimuth,Elevation: single;
begin
     gGLCoords2 := GLCamera1.Position;
     cart2sph( Azimuth,Elevation,gGLCoords2);
     Caption := 'a'+inttostr(round(Azimuth))+'  e'+inttostr(round(Elevation));
     
  //do something
end;
(*var
  n: integer;
  E,Phi,Theta: single;
begin
  Theta := DegToRad(Azimuth-90);
  E := Elevation;
  if (E > 360) or (E < -360)  then begin
    n := trunc(E / 360) ;
    E := E - (n * 360);
  end;
  if ((E > 89) and (E < 91)) or (E < -269) and (E > -271) then
    E := 89.4;
  if ((E > 269) and (E < 271)) or (E < -89) and (E > -91) then
    E := -89.4;
  Phi := DegToRad(E);
  lV.x := r * cos(Phi)*cos(Theta);
  lV.Y := r * cos(Phi)*sin(Theta);
  lV.z := r * sin(Phi);
end;*)


procedure sph2cartDeg(Azimuth,Elevation,R: single; var lV: TGLCoordinates);
//convert spherical AZIMUTH,ELEVATION,RANGE to Cartesion
//see Matlab's [x,y,z] = sph2cart(THETA,PHI,R)
// reverse with cart2sph
var
  n: integer;
  E,Phi,Theta: single;
begin
  Theta := DegToRad(Azimuth-90);
  E := Elevation;
  if (E > 360) or (E < -360)  then begin
    n := trunc(E / 360) ;
    E := E - (n * 360);
  end;
  if ((E > 89) and (E < 91)) or (E < -269) and (E > -271) then
    E := 89.4;
  if ((E > 269) and (E < 271)) or (E < -89) and (E > -91) then
    E := -89.4;
  Phi := DegToRad(E);
  lV.x := r * cos(Phi)*cos(Theta);
  lV.Y := r * cos(Phi)*sin(Theta);
  lV.z := r * sin(Phi);
end;


procedure TGLForm1.Camera2AzimuthElevationDeg(lAzi,lElev: single);
var
  lRange: single;
begin
    lRange := GLCamera1.DistanceToTarget;
    sph2cartDeg(lAzi,lElev,lRange, gGLCoords);
    RepositionCameraX(gGLCoords);
end; //proc Camera2AzimuthElevation

procedure sph2cartDeg90(Azimuth,Elevation,R: single; var lV: TGLCoordinates);
//convert spherical AZIMUTH,ELEVATION,RANGE to Cartesion
//see Matlab's [x,y,z] = sph2cart(THETA,PHI,R)
// reverse with cart2sph
var
  n: integer;
  E,Phi,Theta: single;
begin
  Theta := DegToRad(Azimuth-90);
  E := Elevation;
  if (E > 360) or (E < -360)  then begin
    n := trunc(E / 360) ;
    E := E - (n * 360);
  end;
  if ((E > 89) and (E < 91)) or (E < -269) and (E > -271) then
    E := 90;
  if ((E > 269) and (E < 271)) or (E < -89) and (E > -91) then
    E := -90;
  Phi := DegToRad(E);
  lV.x := r * cos(Phi)*cos(Theta);
  lV.Y := r * cos(Phi)*sin(Theta);
  lV.z := r * sin(Phi);
end;
(*procedure sph2cartDeg90(Azimuth,Elevation,R: single; var lV: TVector);
//convert spherical AZIMUTH,ELEVATION,RANGE to Cartesion
//see Matlab's [x,y,z] = sph2cart(THETA,PHI,R)
// reverse with cart2sph
var
  n: integer;
  E,Phi,Theta: single;
begin
  Theta := DegToRad(Azimuth-90);
  E := Elevation;
  if (E > 360) or (E < -360)  then begin
    n := trunc(E / 360) ;
    E := E - (n * 360);
  end;
  if ((E > 89) and (E < 91)) or (E < -269) and (E > -271) then
    E := 90;
  if ((E > 269) and (E < 271)) or (E < -89) and (E > -91) then
    E := -90;
  Phi := DegToRad(E);
  lV[0] := r * cos(Phi)*cos(Theta);
  lV[1] := r * cos(Phi)*sin(Theta);
  lV[2] := r * sin(Phi);
end; *)


procedure TGLForm1.SetViewerClipPlaneAE (lDistance,lAzi,lElev: integer);
var
  lRange: single;
  lV: TVector;
begin
  if (lDistance = 0) or (lDistance > 1000) then begin
       clip4[0] := -1;
       clip4[1] := 0;
       clip4[2] := 0;
       clip4[3] := 1/2.0;
  end else begin
    sph2cartDeg90(lAzi,lElev,1, gGLCoords3);
    //sph2cartDeg90(lAzi,lElev,lRange, gGLCoords3);
    //gGLcoords3.Normalize;
        //RepositionCameraX(gGLCoords2);
       clip4[0] := -gGLcoords3.X;
       clip4[1] := -gGLcoords3.Y;
       clip4[2] := -gGLcoords3.Z;
       clip4[3] := 0.5-(lDistance/1000);
    UpdateTimer.enabled := true;
  end;
end; //proc SetClipPlane

procedure TGLForm1.SetViewerClipPlane (lDistance: integer);
//var
//  lGLcoords: TGLCoordinates;
begin

  if (lDistance = 0) or (lDistance > 1000) then begin
       //clip4 normally shields dorsal axis from bleeding
       // resetting it can also accelerate render timing
       clip4[0] := -1;
       clip4[1] := 0;
       clip4[2] := 0;
       clip4[3] := 1/2.0;
  end else begin
  //lGLcoords:= TGLCoordinates.Create(self);

      gGLcoords2 := GLCamera1.Position;
    gGLcoords2.Normalize;
       clip4[0] := -gGLcoords2.X;
       clip4[1] := -gGLcoords2.Y;
       clip4[2] := -gGLcoords2.Z;
       clip4[3] := 0.5-(lDistance/1000);
       // lGLcoords.free;
  end;
end; //proc SetClipPlane
procedure TGLForm1.Axial1Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(0,90);
end;

procedure TGLForm1.Axial2Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(180,-90);
end;

procedure TGLForm1.Coronal1Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(180,0);
end; //proc Coronal1Click

procedure TGLForm1.Coronal2Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(0,0);
end; //proc Coronal2Click

procedure TGLForm1.Sagittal1Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(90,0);
end; //proc Sagittal1Click

procedure TGLForm1.Sagittal2Click(Sender: TObject);
begin
  Camera2AzimuthElevationDeg(270,0);
end;

procedure TGLForm1. ViewingDistance(lDin: single);
var
  lDx: single;
begin
  if lDin < 0.01 then //viewing distance of zero loses any sense of camera direction
    lDx := 0.01
  else
    lDx := lDin;
  gGLcoords2 := GLCamera1.Position;
  gGLcoords2.Normalize;
  gGLcoords2.X := gGLcoords2.X * lDx;
  gGLcoords2.Y := gGLcoords2.Y * lDx;
  gGLcoords2.Z := gGLcoords2.Z * lDx;
  GLCamera1.Position := gGLcoords2;
  if GLCamera1.CameraStyle <> csPerspective then begin
    lDx := 1/GLCamera1.DistanceToTarget ;
    GLDirectOpenGL1.Scale.X := lDx*gTexture3D.Scale[1];
      GLDirectOpenGL1.Scale.Y := lDx*gTexture3D.Scale[2];
      GLDirectOpenGL1.Scale.Z := lDx*gTexture3D.Scale[3];
      Frame.Matrix := GLDirectOpenGL1.Matrix;
  end;
end;

procedure TGLForm1.Zoom(WheelDelta: integer);
  //Make image appear closer or further away when user rolls the scroll wheel
	// Note that 1 wheel-step induces a WheelDelta of 120,
	// this code adjusts the distance to target with a 10% per wheel-step ratio
var
  lDx: single;
begin
  lDx := GLCamera1.DistanceToTarget ;
  //caption := floattostr(lDx);
  if (lDx > 10) and (WheelDelta > 0) then exit;
  if (lDx < 0.5) and (WheelDelta < 0) then exit;
  GLCamera1.AdjustDistanceToTarget(Power(1.1, WheelDelta/120));
  if GLCamera1.CameraStyle <> csPerspective then begin
    lDx := kInitialDx/GLCamera1.DistanceToTarget ;
    GLDirectOpenGL1.Scale.X := lDx*gTexture3D.Scale[1];
      GLDirectOpenGL1.Scale.Y := lDx*gTexture3D.Scale[2];
      GLDirectOpenGL1.Scale.Z := lDx*gTexture3D.Scale[3];
      Frame.Matrix := GLDirectOpenGL1.Matrix;
  end;
end;

procedure TGLForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
   {$IFNDEF FPC}
     Zoom(WheelDelta);
    {$ENDIF}
end; //proc FormMouseWheel  -Delphi

procedure TGLForm1.GLSceneViewer1MouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
   {$IFDEF FPC}
     Zoom(WheelDelta);
    {$ENDIF}
end;

procedure TGLForm1.ZoomIn1Click(Sender: TObject);
begin
  Zoom(-120);
end;

procedure TGLForm1.ZoomOut1Click(Sender: TObject);
begin
  Zoom(120);
end;

procedure SetV (var lV: TVector; l0,l1,l2,l3: single);
begin
    lV[0] := l0;
    lV[1] := l1;
    lV[2] := l2;
    lV[3] := l3;
end;

procedure ShowTextWithBorder (lXin,lYin: integer; lS: string; var rci: TRenderContextInfo; lShowBorder: boolean);
var
  lY,lW,lTextH,lX: integer;
begin
  lTextH := GLForm1.GLWindowsBitmapFont1.CharHeight;
  lW := (GLForm1.GLWindowsBitmapFont1.CalcStringWidth(lS));
  lX := lXin - ((lW+1) div 2);
  lY := lYin - (lTextH div 2);
  lW := lW + 2;
  if lShowBorder then begin
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      glEnable (GL_BLEND);
      glColor4ub(gPrefs.TextBorder.rgbRed,gPrefs.TextBorder.rgbGreen,gPrefs.TextBorder.rgbBlue,gPrefs.TextBorder.rgbReserved);
      glBegin(GL_POLYGON);
        glVertex2f(lX,lY);
        glVertex2f(lX,lY+lTextH);
        glVertex2f(lX+lW,lY+lTextH);
        glVertex2f(lX+lW,lY);
      glEnd;//POLYGON
  end;
  lX := lX+1;
  GLForm1.GLWindowsBitmapFont1.TextOut(rci, lX, lY, lS,RGBA2TColor(gPrefs.TextColor));

end;

procedure TGLForm1.ShowOrthoSliceText(var rci: TRenderContextInfo);
const
kTBorder = 10;
kLBorder = 10;
var
  lZoom,lZx,lZy,lZz,lS1,lS2,lS3 : single;
  lDec,lL,lT,lScrnWid,lScrnHt: integer;
  glc: TGLCanvas;
begin
  lZoom := abs(gOrthoZoom);
  SetZooms (lZx,lZy,lZz);
  lZx := lZx * lZoom;
  lZy := lZy * lZoom;
  lZz := lZz * lZoom;
  lScrnWid := GLForm1.GLSceneViewer1.Buffer.Width;
  lScrnHt := GLForm1.GLSceneViewer1.Buffer.Height;
    lS1 := SliceMM (gOrthoX,kSagLeftOrient);
    lS2 := SliceMM (gOrthoY,kCoronalOrient);
    lS3 := SliceMM (gOrthoZ,kAxialOrient);
    lDec := 0;
    glc:=TGLCanvas.Create(lScrnWid,lScrnHt);
    //put 'L'eft on Coronal slice
    lT := round((lZz * gTexture3D.dim[3]) /2);
    ShowTextWithBorder (kLBorder,lT,'L',rci,true);
    //put 'L'eft on Axial slice
    lT :=  round((lZz * gTexture3D.dim[3])+ ((lZy * gTexture3D.dim[2]) /2));
    ShowTextWithBorder (kLBorder,lT,'L',rci,true);
    //put 'X' coordinate on sagittal
    lL := round(  (lZx * gTexture3D.dim[1]) +((lZy * gTexture3D.dim[2]) /2));
    ShowTextWithBorder (lL,kTBorder,realtostr(lS1,lDec),rci,true);
    //put 'Y' coordinate on coronal
    lL := round((lZx * gTexture3D.dim[1]) /2);
    ShowTextWithBorder (lL,kTBorder,realtostr(lS2,lDec),rci,true);
    //put 'Z' coordinate on axial
    lT := round(  (lZz * gTexture3D.dim[3]) +kTBorder);
    ShowTextWithBorder (lL,lT,realtostr(lS3,lDec),rci,true);
    glc.free;
end;

procedure TGLForm1.ShowOrthoSlice (var rci: TRenderContextInfo);
var
  lZ1,lZ2,lZ3,lCorBottom,lCorRight,lZoom,lH,lW,lI,lSlice: single;
  lScrnH,lScrnW: integer;
begin
  SetZooms(lZ1,lZ2,lZ3);
  lScrnH := GLSceneViewer1.height;
  if lScrnH = 0 then
    lScrnH := 1;
  lScrnW := GLSceneViewer1.width;
  if lScrnW = 0 then
    lScrnW := 1;
  lZoom := gOrthoZoom;
  if lZoom <= 0 then begin //autozoom
    lH := lScrnH / (lZ3*gTexture3D.dim[3]+lZ2*gTexture3D.dim[2]);
    lW := lScrnW / (lZ1*gTexture3D.dim[1]+lZ2*gTexture3D.dim[2]);
    if lH < lW then
      lZoom := lH
    else
      lZoom := lW;
    gOrthoZoom := -lZoom;//negative value means automatically adjusted
  end;
  go2D;
  glPushAttrib (GL_ENABLE_BIT);
  glDisable (GL_LIGHTING);
  glBlendFunc (GL_ONE,GL_ZERO{GL_DST_COLOR,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA});
  glEnable (GL_TEXTURE_3D);
  //coronal
  lSlice := gOrthoY;
  lH := lZ3*gTexture3D.dim[3];//coronal image - height is Z axis
  lW := lZ1*gTexture3D.dim[1];//cornal image - width is X axis
  lH := lH/lScrnH*lZoom;
  lW := lW/lScrnW*lZoom;
  lCorBottom := 1-lH;
  lCorRight := lW;

glBegin(GL_QUADS);
      glTexCoord3d (0, lSlice, 1);
      glVertex2f(0,1);
      glTexCoord3d (0,lSlice, 0);
      glVertex2f(0,1-lH);
      glTexCoord3d (1,lSlice,0);
      glVertex2f(lW,1-lH);
      glTexCoord3d (1,lSlice, 1);
      glVertex2f(lW,1);
  glend;
  //axial
  lSlice := gOrthoZ;
  lH := lZ2*gTexture3D.dim[2];//axial image - height is Y axis
  lW := lZ1*gTexture3D.dim[1];//axial image - width is X axis
  lH := lH/lScrnH*lZoom;
  lW := lW/lScrnW*lZoom;
  glBegin(GL_QUADS);
      glTexCoord3d(1, 1, lSlice);
      glVertex2f(lW,lCorBottom);
      glTexCoord3d (0, 1, lSlice);
      glVertex2f(0,lCorBottom);
      glTexCoord3d(0,0, lSlice);
      glVertex2f(0,lCorBottom-lH);
      glTexCoord3d(1, 0, lSlice);
      glVertex2f(lW,lCorBottom-lH);
  glEnd;
  //Sagittal
  lSlice := gOrthoX;
  lH := lZ3*gTexture3D.dim[3];//coronal image - height is Z axis
  lW := lZ2*gTexture3D.dim[2];//cornal image - width is Y axis
  lH := lH/lScrnH*lZoom;
  lW := lW/lScrnW*lZoom;
    if true then //choose left or right profile...
      lI := 1
    else
      lI := 0;
  glBegin(GL_QUADS);
      glTexCoord3d (lSlice, 1-lI, 1);
      glVertex2f(lCorRight,1);
      glTexCoord3d (lSlice, 1-lI, 0);
      glVertex2f(lCorRight,1-lH);
      glTexCoord3d (lSlice,lI,0);
      glVertex2f(lCorRight+lW,1-lH);
      glTexCoord3d (lSlice, lI, 1);
      glVertex2f(lCorRight+lW,1);
  glend;
  glDisable(GL_TEXTURE_3D);
  //next crosshairs...
  if gPrefs.CrossHairs then begin
    if gPrefs.CrosshairThick > 1 then
      glLineWidth(gPrefs.CrosshairThick)
    else
      glLineWidth(1);
    //glColor4f (1,1,1, 0.7);
    glColor4ub(gPrefs.CrossHairColor.rgbRed,gPrefs.CrossHairColor.rgbGreen,gPrefs.CrossHairColor.rgbBlue,gPrefs.CrossHairColor.rgbReserved);


    //glBlendFunc ( GL_SRC_ALPHA, GL_DST_COLOR);
    //glEnable (GL_BLEND);
    glBegin(GL_LINES);
        //X dimension - Coro and Ax
        lH := (lZ2*gTexture3D.dim[2]+lZ3*gTexture3D.dim[3])/lScrnH *lZoom;
        lW := (lZ1*gTexture3D.dim[1]*gOrthoX)/lScrnW * lZoom;
        glVertex2f(lW,1);
        glVertex2f(lW,1-lH);
        //Z dimension - Coro and Sag
        lH := (lZ3*(1-gOrthoZ)*gTexture3D.dim[3])/lScrnH *lZoom;
        lW := (lZ1*gTexture3D.dim[1]+lZ2*gTexture3D.dim[2])/lScrnW * lZoom;
        glVertex2f(0,1-lH);
        glVertex2f(lW,1-lH);
        //Y dimension - Sag
        lH := (lZ3*gTexture3D.dim[3])/lScrnH *lZoom;
        lW := (lZ1*gTexture3D.dim[1]+lZ2*gOrthoY*gTexture3D.dim[2])/lScrnW * lZoom;
        glVertex2f(lW,1);
        glVertex2f(lW,1-lH);
        //Y dimension - Ax
        lH := (lZ2*(1-gOrthoY)*gTexture3D.dim[2]+lZ3*gTexture3D.dim[3])/lScrnH *lZoom;
        lW := (lZ1*gTexture3D.dim[1])/lScrnW * lZoom;
        glVertex2f(0,1-lH);
        glVertex2f(lW,1-lH);
	  glEnd;
  end;
  glPopAttrib;
  end2D;
  if gPrefs.SliceText then
    ShowOrthoSliceText(rci);
end;

procedure TGLForm1.TrackBar1Change(Sender: TObject);
begin
  GLSceneViewer1.Invalidate;
end;

procedure TGLForm1.ApplyCTContrast;
begin
  M_Refresh := TRUE;
    UpdateTimer.Enabled := true;//xx
  //GLSceneViewer1.Refresh;
end;

procedure TGLForm1.DrawMosaic (lStr: string);
var
  lHt,lWid: integer;
   var rci: TRenderContextInfo;
begin
  gDrawMosaicStr := lStr;
  GLSceneViewer1.Enabled := false;
  Frame.Visible := false;
  mosaicGL (gDrawMosaicStr,gTexture3D,lHt,lWid,true,rci);
  GLSceneViewer1.Align := alNone;
  GLSceneViewer1.Height := lHt;
  GLSceneViewer1.Width := lWid;
  GLSceneViewer1.Enabled := true;
  //caption := inttostr(LHt);
  {$IFNDEF FPC} GLSceneViewer1.Refresh; {$ENDIF}//222

end;

procedure TGLForm1.Mosaicdesigner1Click(Sender: TObject);
begin
{$IFDEF ENABLEMOSAIC}
  AdjustFormPos(TFOrm(MosaicPrefsForm));
  MosaicPrefsForm.show;
{$ELSE}
showmessage('Mosaic not enabled in this compilation.');
{$ENDIF}
end;

procedure TGLForm1.ZoomClick(Sender: TObject);
begin
  gOrthoZoom := (Sender as TMenuItem).Tag;
  GLSceneViewer1.Refresh;
end;

procedure TGLForm1.CrossHairs1Click(Sender: TObject);
begin

  gPrefs.CrossHairs := CrossHairs1.checked;
  GLSceneViewer1.refresh;

end;

procedure TGLForm1.Colorandtransarency1Click(Sender: TObject);
begin
  {$IFDEF ENABLECLUT}
  AdjustFormPos(TFOrm(CLUTForm));
  CLUTForm.show;
  {$ELSE}
  showmessage('CLUT not in this compilation.');
  {$ENDIF}
end;

procedure TGLForm1.Scripting1Click(Sender: TObject);
begin
   {$IFDEF ENABLESCRIPT}
  AdjustFormPos(TFOrm(ScriptForm));
  ScriptForm.Show;
  {$ELSE}
  Showmessage('Not compiled with script engine.');
  {$ENDIF}
end;

procedure TGLForm1.SetView(ShowSlicesHideRender, Refresh: boolean);
begin
  gPrefs.OrthoSliceView := ShowSlicesHideRender;
  if not gPrefs.OrthoSliceView then begin
    StopTimers;
    Frame.Visible := FrameMenu.Checked;
    RenderMenu.Visible := true;
    SlicesMenu.visible := false;
    {$IFDEF Darwin}
           Showslicesmenu.ShortCut := ShortCut(Word('G'), [ssMeta]);
           ShowRenderMenu.ShortCut := ShortCut(Word('G'), [ssMeta,ssAlt]);
    {$ELSE}
           Showslicesmenu.ShortCut := ShortCut(Word('G'), [ssCtrl]);
           ShowRenderMenu.ShortCut := ShortCut(Word('G'), [ssCtrl,ssAlt]);
    {$ENDIF}
    //ShowSlicesMenu.Enabled := true;
    //ShowRenderMenu.Enabled := false;
  end else begin
    StopTimers;
    Frame.Visible := false;
    RenderMenu.Visible := false;
    SlicesMenu.visible := true;
    //ShowSlicesMenu.Enabled := false;
    //ShowRenderMenu.Enabled := true;
    {$IFDEF Darwin}
           Showslicesmenu.ShortCut :=ShortCut(Word('G'), [ssMeta,ssAlt]);
           ShowRenderMenu.ShortCut := ShortCut(Word('G'), [ssMeta]);
    {$ELSE}
           Showslicesmenu.ShortCut := ShortCut(Word('G'), [ssCtrl,ssAlt]);
           ShowRenderMenu.ShortCut := ShortCut(Word('G'), [ssCtrl]);
    {$ENDIF}

  end;
  if Refresh then
     UpdateTimer.Enabled := true;
end;

procedure TGLForm1.ShowRenderMenuClick(Sender: TObject);
begin
  SetView(false,true);
end;

procedure TGLForm1.ShowslicesMenuClick(Sender: TObject);
begin
  SetView(true,true);
end;

procedure TGLForm1.AutoRunTimerTimer(Sender: TObject);
begin
  AutoRunTImer.Enabled := false;
  LoadParamStr (true);
end;

procedure TGLForm1.GLSceneViewer1DblClick(Sender: TObject);
begin
  SetView(not gPrefs.OrthoSliceView,true);
end;

procedure TGLForm1.UpdateTimerTimer(Sender: TObject);
begin
  UpdateTimer.Enabled := false;
  {$IFDEF ENABLECLUT}
  if gRefreshClut then begin
       //GLForm1.ApplyCTContrast;

       CLUTForm.DrawCLUTa(gCLUTrec);
       M_Refresh := TRUE;
  end;
  {$ENDIF}
   gRefreshClut := false;
  GLForm1.GLSceneViewer1.invalidate;
end;

procedure TGLForm1.Overlays1Click(Sender: TObject);
begin
{$IFDEF ENABLEOVERLAY}
  AdjustFormPos(TFOrm(OverlayForm));
  OverlayForm.show;
{$ELSE}
  showmessage('Overlays not in this compilation.');
{$ENDIF}
end;


procedure TGLForm1.ColorbarFormMenuClick(Sender: TObject);
begin
{$IFDEF ENABLECOLORBAR}
  AdjustFormPos(TFOrm(ColorbarForm));
  ColorbarForm.show;
{$ELSE}
showmessage('Colorbar form not enabled in this compilation.');
{$ENDIF}
end;

procedure TGLForm1.SliceTextMenu1Click(Sender: TObject);
begin
   {$IFDEF FPC} SliceTextMenu1.Checked := not SliceTextMenu1.Checked; {$ENDIF}
  gPrefs.SliceText := SliceTextMenu1.checked;
  GLSceneViewer1.refresh;
end;

procedure TGLForm1.MedianSmoothing;
begin
  if gTexture3D.FiltImg = nil then
        exit;
  MedianSmoothVolume(gTexture3D);
  M_Refresh := true;
  {$IFNDEF Darwin}
  UpdateTimer.Enabled := true;
  {$ENDIF}
end;

procedure TGLForm1.EdgedetectionX (lThresh: single; lDilateCycles: integer);
begin
  if gTexture3D.FiltImg = nil then
        exit;
  EdgeDetectZ (gTexture3D,gCLUTrec.min,gCLUTrec.max,lThresh,lDilateCycles);
  M_Refresh := true;
  {$IFNDEF Darwin}
  UpdateTimer.Enabled := true;
  {$ENDIF}
end;

procedure TGLForm1.DecimateV (lPercent: integer);
begin
  if gTexture3D.FiltImg = nil then
        exit;
  DecimateVol (gTexture3D,lPercent);
  M_Refresh := true;
  {$IFNDEF Darwin}
  UpdateTimer.Enabled := true;
  {$ENDIF}
end;

procedure TGLForm1.Crosshairthickness1Click(Sender: TObject);

begin
  gPrefs.CrosshairThick := ReadIntForm.GetInt('Set crosshair width',1,gPrefs.CrosshairThick,12);
  GLSceneViewer1.Refresh;
end;

procedure TGLForm1.Options1Click(Sender: TObject);
begin
  {$IFDEF ENABLEPREF}
    {$IFDEF ENABLECLUT}
    //many settings adjust appearance of LUT form...
    AdjustFormPos(TFOrm(CLUTForm));
    CLUTForm.show;
    {$ENDIF}
  AdjustFormPos(TFOrm(PrefsForm));
  PrefsForm.show;
  {$ELSE}
  showmessage('Prefs not in this compilation.');
  {$ENDIF}
end;

procedure TGLForm1.FormShow(Sender: TObject);
begin
  //LoadDTI('aq');
end;

initialization
{$IFDEF FPC}
//    GLSceneViewer1.Buffer.AntiAliasing  := aa4xHQ
  {$I mainunit.lrs}
{$ENDIF}
end.

