unit smooth;
interface

uses define_types, dialogs,Texture_3D_Unit,OpenGL1x, {Windows,} IniFiles, Prefs,StdCtrls,Classes;

procedure MedianSmoothVolume (var lTexture: TTexture);

implementation


uses SysUtils, mainunit,histogram;

(*procedure EdgeDetectVol (var lIntenVolume: bytep0; lX,lY,lZ: integer; lThreshIn: single);
var
  lNeighborInten,lCenterInten,lCenterInten6,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  ValueI,lVox,lnVox: integer;
  lOutVolume: bytep0;
  lThresh,lF: single;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  if lThreshIn > 0.000001 then
    lThresh := lThreshIn
  else
    lThresh := 1;
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lCenterInten := lIntenVolume^[lPos];
        lCenterInten6 := lCenterInten*6;
        lNeighborInten :=
          lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
          +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
          +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
        if lCenterInten6 > lNeighborInten then begin
          lCenterInten6 := lCenterInten6-lNeighborInten;
          lF := lCenterInten  / lThresh;
          if lCenterInten6 > lF then
            lOutVolume^[lPos] := 255;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure DespeckleVol (var lIntenVolume: bytep0; lX,lY,lZ: integer);
var
  lNeighborInten,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  lnVox: integer;
  lOutVolume: bytep0;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lOutVolume^[lPos] := lIntenVolume^[lPos];
        if lIntenVolume^[lPos] <> 0 then begin
          lNeighborInten :=
            lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
            +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
            +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
          if lNeighborInten = 0 then
            lOutVolume^[lPos] := 0;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure GrowVol (var lIntenVolume: bytep0; lX,lY,lZ: integer);
var
  lNeighborInten,
  lPos,lSliceStart,lLineStart,
  lXi,lYi,lZi,lXY,
  ValueI,lnVox: integer;
  lOutVolume: bytep0;
begin
  lXY := lX * lY;
  lnVox := lXY*lZ;
  if (lnVox < 0) or (lX < 3) or (lY < 3) or (lZ < 3) then
      exit;
  getmem(lOutVolume,lnVox);
  fillchar(lOutVolume^,lnVox,0);//we will not fill the edges...
  for lZi := 2 to (lZ -1) do begin
    lSliceStart := (lZi-1)*lXY;
    for lYi := 2 to (lY -1) do begin
      lLineStart := (lYi-1) * lX;
      for lXi := 2 to (lX-1) do begin
        lPos := (lXi-1)+lSliceStart+lLineStart;
        lOutVolume^[lPos] := lIntenVolume^[lPos];
        if lIntenVolume^[lPos] = 0 then begin
          lNeighborInten :=
            lIntenVolume^[lPos-1]+lIntenVolume^[lPos+1] //X
            +lIntenVolume^[lPos-lX]+lIntenVolume^[lPos+lX] //Y
            +lIntenVolume^[lPos-lXY]+lIntenVolume^[lPos+lXY]; //Z
          if lNeighborInten <> 0 then
            lOutVolume^[lPos] := 255;
        end;
      end;//lX
    end;//lY
  end; //lZ
  //next copy output...
  Move(lOutVolume^,lIntenVolume^,lnVox);//source/dest
  freemem(lOutVolume);
end;

procedure MaskVolume (var lTexture: TTexture; var lIntenVolume: bytep0);
var
  lVox,lnVox,ValueI: integer;
begin
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  if lTexture.RawUnscaledImg16 <> nil then begin //16
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
        lTexture.RawUnscaledImg16^[lVox] := 0;
  end else if lTexture.RawUnscaledImg32 <> nil then begin //32-bit
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
        lTexture.RawUnscaledImg32^[lVox] := 0;
  end else if (lTexture.RawUnscaledImg8 <> nil) then begin //8-bit
    for lVox := 0 to lnVox do
      if lIntenVolume^[lVox] = 0 then
           lTexture.RawUnscaledImg8^[lVox] := 0;
  end else if (lTexture.RawUnscaledImgRGBA <> nil) then begin
    ValueI := 0; //indexed from 0, RGBA quad
    for lVox := 1 to lnVox do begin
      if lIntenVolume^[lVox] = 0 then begin
        lTexture.RawUnscaledImgRGBA^[ValueI] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+1] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+2] := 0;
        lTexture.RawUnscaledImgRGBA^[ValueI+3] := 0;
      end;
      ValueI := ValueI + 4;
    end;
  end;
end;

procedure DecimateVol (var lTexture: TTexture; lPercent: integer);
//%=100 deletes all voxels, %=25 deletes one quarter
var
  lVox,lnVox: integer;
  lIntenVolume: bytep0;
  ValueI: byte;
begin
  if lTexture.DataType <> GL_RGBA then
    exit;
  if lTexture.FiltImg = nil then
    exit;
  if (lPercent < 1) or (lPercent > 99) then
    exit;
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3]-1;
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  getmem(lIntenVolume,lnVox);
  for lVox := 0 to lnVox do begin
            if random(100) > lPercent then
              ValueI := 0
          else
               ValueI := 255;
           lIntenVolume^[lVox] := ValueI;
  end; //for each vox
  MaskVolume (lTexture, lIntenVolume);
  freemem(lIntenVolume);
end;
                   *)
(*procedure TImgForm.Quicksmooth1Click(Sender: TObject);
var
 lHdr: TMRicroHdr;
 lXDim,lYDim,lZDim,lMaxGray,lSum,lMinWt,lMaxWt,lMinInten,lMaxInten,lOutVolVox,lOutSliceSz,lX,lY,lZ,lXxi,l2,lZyi: integer;
 lSum32,lMinInten32,lMaxInten32: single;
 lTempBuff,lSrcBuff: Bytep;
 l16TempBuff,l16SrcBuff: SmallIntP;
 l32TempBuff,l32SrcBuff: SingleP;
procedure AddPoint (lInten,lWeight:integer);
begin
	lSum := lSum + (lInten*lWeight);
	if lInten <= lMinInten then begin
	   lMinWt := lWeight;
	   lMinInten := lInten;
	end else if lInten >= lMaxInten then begin
	   lMaxWt := lWeight;
	   lMaxInten := lInten;
	end;
end;  //nested AddPoint
procedure AddPoint32 (lInten32: single; lWeight:integer);
begin
	lSum32 := lSum32 + (lInten32*lWeight);
	if lInten32 <= lMinInten32 then begin
	   lMinWt := lWeight;
	   lMinInten32 := lInten32;
	end else if lInten32 >= lMaxInten32 then begin
       lMaxWt := lWeight;
	   lMaxInten32 := lInten32;
	end;
end;  //nested AddPoint32
begin
  lHdr := gMRIcroOverlay[kBGOverlayNum];
  //tempo
  lXDim := gBGImg.ScrnDim[1];
  lYDim := gBGImg.ScrnDim[2];
  lZDim := gBGImg.ScrnDim[3];
  lOutSliceSz := gBGImg.ScrnDim[1] * gBGImg.ScrnDim[2];
  lOutVolVox :=  lOutSliceSz * lZDim;
  if (lXDim < 3) or (lYDim < 3) or (lZDim < 3) or (lOutVolVox < 36) then begin
	 showmessage('The 3D smoothing can only be applied to images with at least 3 slices in each dimension.');
	 exit;
  end;
  if (lHdr.ImgBufferItems < 1) then begin
	  showmessage('Please first load the image you would like to smooth.');
	  exit;
  end;
  ProgressBar1.Min := 0;
  ProgressBar1.Max :=lZDim;
  StatusLabel.caption := 'Removing noise speckles and smoothing data [blur]';
  if  lHdr.ImgBufferBPP = 4 then begin //32-bit float data
	l32SrcBuff := SingleP(lHdr.ImgBuffer);
	GetMem(l32TempBuff,lOutVolVox*sizeof(single));
    Move(l32SrcBuff^,l32TempBuff^,lOutVolVox*sizeof(single));
	for lZ := 1 to lOutVolVox do
		l32SrcBuff[lZ] := 0;
	for lZ := lZDim-1 downto 2 do begin
		ProgressBar1.Position := (lZDim-lZ);
		for lY := lYDim-1 downto 2 do begin
			lZyi := ((lZ-1)*lOutSliceSz) + ((lY-1) * lXDim);
			for lX := lXDim-1 downto 2 do begin
                lXxi := lZyi + lX;
				//next: gaussian mean after min/max values are excluded
                lSum32 := 0;
				lMinInten32 := l32TempBuff[lXxi];
                lMaxInten32 := l32TempBuff[lXxi];
				lMinWt := 12;
                lMaxWt := 12;
				AddPoint32(l32TempBuff[lXxi],12);//quad-weight center
				AddPoint32(l32TempBuff[lXxi-lOutSliceSz],2);//prev slice
				AddPoint32(l32TempBuff[lXxi+lOutSliceSz],2);//next slices
				AddPoint32(l32TempBuff[lXxi-1],2);//Left
				AddPoint32(l32TempBuff[lXxi+1],2);//right
				AddPoint32(l32TempBuff[lXxi-lXDim],2);//up
				AddPoint32(l32TempBuff[lXxi+lXDim],2);//down
				AddPoint32(l32TempBuff[lXxi-lOutSliceSz-1],1);
				AddPoint32(l32TempBuff[lXxi-lOutSliceSz+1],1);
				AddPoint32(l32TempBuff[lXxi-lOutSliceSz-lXDim],1);
				AddPoint32(l32TempBuff[lXxi-lOutSliceSz+lXDim],1);
				AddPoint32(l32TempBuff[lXxi+lOutSliceSz-1],1);
				AddPoint32(l32TempBuff[lXxi+lOutSliceSz+1],1);
				AddPoint32(l32TempBuff[lXxi+lOutSliceSz-lXDim],1);
				AddPoint32(l32TempBuff[lXxi+lOutSliceSz+lXDim],1);
				AddPoint32(l32TempBuff[lXxi-lXDim-1],1);
				AddPoint32(l32TempBuff[lXxi+lXDim-1],1);
				AddPoint32(l32TempBuff[lXxi-lXDim+1],1);
				AddPoint32(l32TempBuff[lXxi+lXDim+1],1);
				if lMinInten = lMaxInten then
				   l32SrcBuff[lXxi] := lMaxInten32 //no variability in data
				else begin
					 l2 := 36 - lMinWt -lMaxWt;  //weight after we exceed brightest and darkest
					 lSum32 := lSum32 -(lMinWt*lMinInten32) - (lMaxWt*lMaxInten32); //exclude brightest/darkest
					 l32SrcBuff[lXxi] := (lSum32/l2);
				end;
			end; //forX
		end; //forY
	end; //forZ
	Freemem(l32TempBuff);
  end else if (lHdr.ImgBufferBPP = 2) then begin //16-bit int data
	l16SrcBuff :=  SmallIntP(lHdr.ImgBuffer );
	GetMem(l16TempBuff,lOutVolVox*sizeof(word));
	Move(l16SrcBuff^,l16TempBuff^,lOutVolVox*sizeof(word));
	for lZ := 1 to lOutVolVox do
		l16SrcBuff[lZ] := 0;
	for lZ := lZDim-1 downto 2 do begin
		ProgressBar1.Position := (lZDim-lZ);
		for lY := lYDim-1 downto 2 do begin
			lZyi := ((lZ-1)*lOutSliceSz) + ((lY-1) * lXDim);
			for lX := lXDim-1 downto 2 do begin
				lXxi := lZyi + lX;
				//next: gaussian mean after min/max values are excluded
				lSum := 0;
				lMinInten := l16TempBuff[lXxi];
				lMaxInten := l16TempBuff[lXxi];
				lMinWt := 12;
				lMaxWt := 12;
				AddPoint(l16TempBuff[lXxi],12);//quad-weight center
				AddPoint(l16TempBuff[lXxi-lOutSliceSz],2);//prev slice
				AddPoint(l16TempBuff[lXxi+lOutSliceSz],2);//next slices
                AddPoint(l16TempBuff[lXxi-1],2);//Left
				AddPoint(l16TempBuff[lXxi+1],2);//right
				AddPoint(l16TempBuff[lXxi-lXDim],2);//up
				AddPoint(l16TempBuff[lXxi+lXDim],2);//down
                AddPoint(l16TempBuff[lXxi-lOutSliceSz-1],1);
				AddPoint(l16TempBuff[lXxi-lOutSliceSz+1],1);
				AddPoint(l16TempBuff[lXxi-lOutSliceSz-lXDim],1);
				AddPoint(l16TempBuff[lXxi-lOutSliceSz+lXDim],1);
				AddPoint(l16TempBuff[lXxi+lOutSliceSz-1],1);
				AddPoint(l16TempBuff[lXxi+lOutSliceSz+1],1);
                AddPoint(l16TempBuff[lXxi+lOutSliceSz-lXDim],1);
				AddPoint(l16TempBuff[lXxi+lOutSliceSz+lXDim],1);
				AddPoint(l16TempBuff[lXxi-lXDim-1],1);
				AddPoint(l16TempBuff[lXxi+lXDim-1],1);
                AddPoint(l16TempBuff[lXxi-lXDim+1],1);
				AddPoint(l16TempBuff[lXxi+lXDim+1],1);
                if lMinInten = lMaxInten then
				   l16SrcBuff[lXxi] := lMaxInten //no variability in data
                else begin
					 l2 := 36 - lMinWt -lMaxWt;  //weight after we exceed brightest and darkest
                     lSum := lSum -(lMinWt*lMinInten) - (lMaxWt*lMaxInten); //exclude brightest/darkest
					 l16SrcBuff[lXxi] := round(lSum/l2);
                end;
			end; //forX
		end; //forY
	end; //forZ
	Freemem(l16TempBuff);
	//OptimizeSingle(nil);
  end else if lHdr.ImgBufferBPP = 1 then begin //8-bit data
	  lSrcBuff := lHdr.ImgBuffer;
   GetMem(lTempBuff,lOutVolVox);
   Move(lSrcBuff^,lTempBuff^,lOutVolVox);
   fillchar(lSrcBuff^,lOutVolVox,0); //set edges to 0, as outside voxel is not smoothed
   for lZ := lZDim-1 downto 2 do begin
		ProgressBar1.Position := (lZDim-lZ);
		for lY := lYDim-1 downto 2 do begin
			lZyi := ((lZ-1)*lOutSliceSz) + ((lY-1) * lXDim);
			for lX := lXDim-1 downto 2 do begin
				lXxi := lZyi + lX;
				//next: gaussian mean after min/max values are excluded
				lSum := 0;
				lMinInten := lTempBuff[lXxi];
				lMaxInten := lTempBuff[lXxi];
				lMinWt := 12;
				lMaxWt := 12;
				AddPoint(lTempBuff[lXxi],12);//quad-weight center
				AddPoint(lTempBuff[lXxi-lOutSliceSz],2);//prev slice
                AddPoint(lTempBuff[lXxi+lOutSliceSz],2);//next slices
				AddPoint(lTempBuff[lXxi-1],2);//Left
				AddPoint(lTempBuff[lXxi+1],2);//right
				AddPoint(lTempBuff[lXxi-lXDim],2);//up
                AddPoint(lTempBuff[lXxi+lXDim],2);//down
				AddPoint(lTempBuff[lXxi-lOutSliceSz-1],1);
                AddPoint(lTempBuff[lXxi-lOutSliceSz+1],1);
				AddPoint(lTempBuff[lXxi-lOutSliceSz-lXDim],1);
                AddPoint(lTempBuff[lXxi-lOutSliceSz+lXDim],1);
				AddPoint(lTempBuff[lXxi+lOutSliceSz-1],1);
				AddPoint(lTempBuff[lXxi+lOutSliceSz+1],1);
				AddPoint(lTempBuff[lXxi+lOutSliceSz-lXDim],1);
                AddPoint(lTempBuff[lXxi+lOutSliceSz+lXDim],1);
				AddPoint(lTempBuff[lXxi-lXDim-1],1);
                AddPoint(lTempBuff[lXxi+lXDim-1],1);
				AddPoint(lTempBuff[lXxi-lXDim+1],1);
				AddPoint(lTempBuff[lXxi+lXDim+1],1);
				if lMinInten = lMaxInten then
				   lSrcBuff[lXxi] := lMaxInten //no variability in data
				else begin
					 l2 := 36 - lMinWt -lMaxWt;  //weight after we exceed brightest and darkest
					 lSum := lSum -(lMinWt*lMinInten) - (lMaxWt*lMaxInten); //exclude brightest/darkest
					 lSrcBuff[lXxi] := round(lSum/l2);
				end;
			end; //forX
		end; //forY
	end; //forZ
	Freemem(lTempBuff);
  end else begin //8bit data
      showmessage('Unknown bits per pixel '+inttostr(lHdr.ImgBufferBPP) );
  end;
	ProgressBar1.Position := 0;
		RescaleImgIntensity(gBGImg,gMRIcroOverlay[kBGOverlayNum],kBGOverlayNum);
	RefreshImagesTimer.Enabled := true;
end; //quicksmooth
*)

procedure Quicksmooth1(l32SrcBuff: singlep0; lXDim,lYDim,lZDim: integer);
var
  l2 ,lZyi,lXxi,lZ,lY,lX,lMinWt,lMaxWt,lOutVolVox,lOutSliceSz: integer;
  lMinInten32,lMaxInten32,lSum32: single;
  l32TempBuff: singlep0;
procedure AddPoint32 (lInten32: single; lWeight:integer);
begin
	lSum32 := lSum32 + (lInten32*lWeight);
	if lInten32 <= lMinInten32 then begin
	   lMinWt := lWeight;
	   lMinInten32 := lInten32;
	end else if lInten32 >= lMaxInten32 then begin
       lMaxWt := lWeight;
	   lMaxInten32 := lInten32;
	end;
end;  //nested AddPoint32
begin
  lOutSliceSz := lXDim*lYDim;
  lOutVolVox :=  lOutSliceSz * lZDim;
  if (lXDim < 3) or (lYDim < 3) or (lZDim < 3) or (lOutVolVox < 36) then begin
	 showmessage('The 3D smoothing can only be applied to images with at least 3 slices in each dimension.');
	 exit;
  end;
  //StatusLabel.caption := 'Removing noise speckles and smoothing data [blur]';
	GetMem(l32TempBuff,lOutVolVox*sizeof(single));
  Move(l32SrcBuff^,l32TempBuff^,lOutVolVox*sizeof(single));
	for lZ := 1 to lOutVolVox do
		l32SrcBuff^[lZ] := 0;
	for lZ := lZDim-1 downto 2 do begin
		for lY := lYDim-1 downto 2 do begin
			lZyi := ((lZ-1)*lOutSliceSz) + ((lY-1) * lXDim);
			for lX := lXDim-1 downto 2 do begin
                lXxi := lZyi + lX -1;//-1 as indexed from zero
				//next: gaussian mean after min/max values are excluded
                lSum32 := 0;
				lMinInten32 := l32TempBuff^[lXxi];
                lMaxInten32 := l32TempBuff^[lXxi];
				lMinWt := 12;
                lMaxWt := 12;
				AddPoint32(l32TempBuff^[lXxi],12);//quad-weight center
				AddPoint32(l32TempBuff^[lXxi-lOutSliceSz],2);//prev slice
				AddPoint32(l32TempBuff^[lXxi+lOutSliceSz],2);//next slices
				AddPoint32(l32TempBuff^[lXxi-1],2);//Left
				AddPoint32(l32TempBuff^[lXxi+1],2);//right
				AddPoint32(l32TempBuff^[lXxi-lXDim],2);//up
				AddPoint32(l32TempBuff^[lXxi+lXDim],2);//down
				AddPoint32(l32TempBuff^[lXxi-lOutSliceSz-1],1);
				AddPoint32(l32TempBuff^[lXxi-lOutSliceSz+1],1);
				AddPoint32(l32TempBuff^[lXxi-lOutSliceSz-lXDim],1);
				AddPoint32(l32TempBuff^[lXxi-lOutSliceSz+lXDim],1);
				AddPoint32(l32TempBuff^[lXxi+lOutSliceSz-1],1);
				AddPoint32(l32TempBuff^[lXxi+lOutSliceSz+1],1);
				AddPoint32(l32TempBuff^[lXxi+lOutSliceSz-lXDim],1);
				AddPoint32(l32TempBuff^[lXxi+lOutSliceSz+lXDim],1);
				AddPoint32(l32TempBuff^[lXxi-lXDim-1],1);
				AddPoint32(l32TempBuff^[lXxi+lXDim-1],1);
				AddPoint32(l32TempBuff^[lXxi-lXDim+1],1);
				AddPoint32(l32TempBuff^[lXxi+lXDim+1],1);
				if lMinInten32 = lMaxInten32 then
				   l32SrcBuff^[lXxi] := lMaxInten32 //no variability in data
				else begin
					 l2 := 36 - lMinWt -lMaxWt;  //weight after we exceed brightest and darkest
					 lSum32 := lSum32 -(lMinWt*lMinInten32) - (lMaxWt*lMaxInten32); //exclude brightest/darkest
					 l32SrcBuff^[lXxi] := (lSum32/l2);
				end;
			end; //forX
		end; //forY
	end; //forZ
	Freemem(l32TempBuff);
end; //quicksmooth

procedure MedianSmoothVolume (var lTexture: TTexture);
var
  lVox,lnVox: integer;
  lIntenVolume: singlep0;
begin
  if lTexture.DataType <> GL_RGBA then
    exit;
  if lTexture.FiltImg = nil then
    exit;
  lnVox := lTexture.Dim[1]*lTexture.Dim[2]*lTexture.Dim[3];
  if (lnVox < 0) or (lTexture.Dim[1] < 3) or (lTexture.Dim[2] < 3) or (lTexture.Dim[3] < 3) then
      exit;
  getmem(lIntenVolume,(lnVox+1)* sizeof(single));
  if lTexture.RawUnscaledImg16 <> nil then begin //16
    for lVox := 0 to (lnVox-1) do
            lIntenVolume^[lVox] := lTexture.RawUnscaledImg16^[lVox];
  end else if lTexture.RawUnscaledImg32 <> nil then begin //32-bit
    Move(lTexture.RawUnscaledImg32^,lIntenVolume^, lnVox*sizeof(single));
  end else if (lTexture.RawUnscaledImg8 <> nil) then begin //8-bit
    for lVox := 0 to (lnVox-1) do
           lIntenVolume^[lVox] := lTexture.RawUnscaledImg8^[lVox];
  end else if (lTexture.RawUnscaledImgRGBA <> nil) then begin
    exit;
  end else begin
      freemem(lIntenVolume);
      Showmessage('Serious error with Median+Smooth filter: unknown datatype.');
      exit;
  end;
  Quicksmooth1(lIntenVolume,lTexture.Dim[1],lTexture.Dim[2],lTexture.Dim[3]);



  if lTexture.RawUnscaledImg16 <> nil then begin //16
    for lVox := 0 to (lnVox-1) do
      lTexture.RawUnscaledImg16^[lVox] := round(lIntenVolume^[lVox]);
  end else if lTexture.RawUnscaledImg32 <> nil then begin //32-bit
    Move(lIntenVolume^, lTexture.RawUnscaledImg32^,lnVox*sizeof(single));
  end else if (lTexture.RawUnscaledImg8 <> nil) then begin //8-bit
    for lVox := 0 to (lnVox-1) do
      lTexture.RawUnscaledImg8^[lVox] := round(lIntenVolume^[lVox]);
  end;
  freemem(lIntenVolume);

end;


end.
