unit uprefsform;

interface
{$include options.inc}

{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
uses
{$IFDEF FPC}LResources,
{$ELSE} //Delphi   Windows,
{$ENDIF}
   Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,define_types,PRefs;
type
  { TPrefsForm }
  TPrefsForm = class(TForm)
    IntelCheck: TCheckBox;
    RenderDrop: TComboBox;
    PowerOfTwoCheck: TCheckBox;
    Label1: TLabel;
    GridColorBtn: TButton;
    HistoCOlorBtn: TButton;
    ColorDialog1: TColorDialog;
    TextColorBtn: TButton;
    TextBorderColorBtn: TButton;
    ColorbarborderBtn: TButton;
    Label2: TLabel;
    DefBtn: TButton;
    CancelBtn: TButton;
    OKBtn: TButton;
    //RenderDrop: TComboBox;
    Label3: TLabel;
    procedure CheckChange(Sender: TObject);
    procedure LowResCheckChange(Sender: TObject);
    procedure UpdateX;
    procedure GridColorBtnClick(Sender: TObject);
    procedure HistoCOlorBtnClick(Sender: TObject);
    procedure TextColorBtnClick(Sender: TObject);
    procedure TextBorderColorBtnClick(Sender: TObject);
    procedure ColorbarborderBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var lAction: TCloseAction);
    procedure DefBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PrefsForm: TPrefsForm;

implementation

uses mainunit
{$IFDEF ENABLECLUT}, clutprefs  {$ENDIF};
var
  gBackupPrefs: TPrefs;
{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}

procedure TPrefsForm.UpdateX;
begin
  {$IFDEF Darwin}
  GLForm1.SetView(gPrefs.OrthoSliceView,true);
  {$ELSE}
  GLForm1.SetView(gPrefs.OrthoSliceView,true);
  {$ENDIF}
  PowerOfTwoCheck.Checked := gPrefs.ForcePowerOfTwo;
  //LowResCheck.Checked := gPrefs.LowResolutionRendering;
  IntelCheck.Checked := gPrefs.IntelWarning;
  if (gPrefs.RenderQuality < kNoRender) or ( gPrefs.RenderQuality > kNormalRender) then
    gPrefs.RenderQuality := kNormalRender;
  RenderDrop.itemindex := gPrefs.RenderQuality;
  {$IFDEF ENABLECLUT}
  CLUTForm.HistogramColors;
  {$ENDIF}
end;

(*procedure TPrefsForm.PowerOfTwoCheckChange(Sender: TObject);
begin
  //gPrefs.ForcePowerOfTwo:=  PowerOfTwoCheck.checked;
  UpdateX;
  GLForm1.OpenMRU(nil);
end;

procedure TPrefsForm.LowResCheckChange(Sender: TObject);
begin
  gPrefs.LowResolutionRendering:= LowResCheck.Checked;
  UpdateX;
end; *)

procedure TPrefsForm.CheckChange(Sender: TObject);
begin
  gPrefs.ForcePowerOfTwo:=  PowerOfTwoCheck.checked;
  gPrefs.RenderQuality := RenderDrop.itemindex;
  //gPrefs.LowResolutionRendering:= LowResCheck.Checked;
  UpdateX;
  GLForm1.OpenMRU(nil);
end;

procedure TPrefsForm.LowResCheckChange(Sender: TObject);
begin
  //gPrefs.LowResolutionRendering:= LowResCheck.Checked;
  if not PrefsForm.Visible then
    exit;
  gPrefs.RenderQuality := RenderDrop.ItemIndex;
    gPrefs.IntelWarning := IntelCheck.checked;
  UpdateX;
end;

procedure TPrefsForm.GridColorBtnClick(Sender: TObject);
begin
    ColorDialog1.color := gPrefs.CLUTWindowColor;
    if not ColorDialog1.Execute then begin
      PrefsForm.BringToFront;
      exit;
    end;
    PrefsForm.BringToFront;
    gPrefs.CLUTWindowColor := ColorDialog1.Color;
    UpdateX;
end;

procedure TPrefsForm.HistoCOlorBtnClick(Sender: TObject);
begin
    ColorDialog1.color := gPrefs.CLUTIntensityColor;
    if not ColorDialog1.Execute then begin
      PrefsForm.BringToFront;
      exit;
    end;
    PrefsForm.BringToFront;
    gPrefs.CLUTIntensityColor := ColorDialog1.Color;
    UpdateX;
end;

procedure TPrefsForm.TextColorBtnClick(Sender: TObject);
begin
   ColorDialog1.color := RGBA2TColor(gPrefs.TextColor);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.TextColor);
    UpdateX;
end;

procedure TPrefsForm.TextBorderColorBtnClick(Sender: TObject);
begin
   ColorDialog1.color := RGBA2TColor(gPrefs.TextBorder);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.TextBorder);
    UpdateX;
end;

procedure TPrefsForm.ColorbarborderBtnClick(Sender: TObject);
begin
   ColorDialog1.color := RGBA2TColor(gPrefs.ColorBarBorder);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.ColorBarBorder);
    UpdateX;
end;

procedure TPrefsForm.FormClose(Sender: TObject; var lAction: TCloseAction);
begin
  UpdateX;
end;

procedure TPrefsForm.DefBtnClick(Sender: TObject);
begin
   SetDefaultPrefs(gPrefs,True);
   UpdateX;
end;

procedure TPrefsForm.OKBtnClick(Sender: TObject);
begin
  UpdateX;
  Close;
end;

procedure TPrefsForm.CancelBtnClick(Sender: TObject);
begin
  gPrefs := gBackupPrefs;
  UpdateX;
  Close;
end;

procedure TPrefsForm.FormShow(Sender: TObject);
begin
  gBackupPrefs := gPrefs;
  RenderDrop.ItemIndex := gPrefs.RenderQuality;
  UpdateX;
end;

initialization
{$IFDEF FPC}
    {$I uprefsform.lrs}
{$ENDIF}
end.
